package reti;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.util.ArrayList;
import javax.swing.*;

/**
 * Title:        Progetto di reti di calcolatori
 * Description:  Sistema di server commerciali per la vendita di prodotti via internet
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Alessandro Celli
 * @version 1.0
 */

public class Client extends Applet {
  // *************************** VARIABILI DI CONFIGURAZIONE ****************************
  String ipServ;        // IP del server primario
  int portServ;         // Porta del server primario
  long CL;              // Clock Logico
  String cliCode;       // Codice del cliente
  ArrayList serverList; // Vettore contenente la lista dei server disponibili
  int servListSize=1;   // specifica quali dei primi n dati della lista sono validi
  // ************************************ STREAM DATI ***********************************
  BufferedReader In;    // Stream per la gestione dell'Input per la socket con il server
  BufferedWriter Out;   // Stream per la gestione dell'Output per la socket con il server
  // ************************************** SOCKET **************************************
  Socket cliSocket;     // socket per il dialogo con il Server primario
  // ********************** VARIABILI PER LA GESTIONE DEI PRODOTTI **********************
  ArrayList codeProduct; // Codice dei prodotti selezionati dall'utente
  ArrayList numberProduct; // Quantit, per un dato prodotto, selezionate dall'utente
  // ************************** INTERFACCIA GRAFICA E SUPPORTO **************************
  boolean isStandalone = false;
  TextArea msgBox = new TextArea();
  List listProd = new List();
  List orderProd = new List();
  Button btn_addProd = new Button();
  Button btn_removeProd = new Button();
  Button btn_connect = new Button();
  Button bnt_deconnect = new Button();
  Button bnt_listProd = new Button();
  Button btn_sendOrder = new Button();
  Button btn_removeOrder = new Button();
  TextField fld_removeOrder = new TextField();
  Button btn_mostraConfig = new Button();
  Button btn_ClearText = new Button();
  TextField quantita = new TextField();
  Label label1 = new Label();
  Button btn_close = new Button();

  /**Get a parameter value*/
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  /**Construct the applet*/
  public Client() {
  }
  /**Initialize the applet*/
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception {
    this.setLayout(null);
    btn_connect.setActionCommand("connect");     // Connessione al server
    btn_connect.setLabel("Connetti");
    btn_connect.setBounds(new Rectangle(5, 10, 170, 25));
    btn_connect.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_connect_actionPerformed(e);
      }
    });
    bnt_deconnect.setActionCommand("deconnect");    // Disconnessione dal server
    bnt_deconnect.setLabel("Sconnetti");
    bnt_deconnect.setBounds(new Rectangle(5, 35, 170, 25));
    bnt_deconnect.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bnt_deconnect_actionPerformed(e);
      }
    });
    bnt_listProd.setActionCommand("listProd");    // Lista dei prodotti
    bnt_listProd.setLabel("Richiedi lista prodotti");
    bnt_listProd.setBounds(new Rectangle(5, 70, 170, 25));
    bnt_listProd.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bnt_listProd_actionPerformed(e);
      }
    });
    btn_sendOrder.setActionCommand("sendOrder");   // Invio ordine
    btn_sendOrder.setLabel("Invia Ordine");
    btn_sendOrder.setBounds(new Rectangle(5, 95, 170, 25));
    btn_sendOrder.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_sendOrder_actionPerformed(e);
      }
    });
    btn_mostraConfig.setActionCommand("mostraConfig");
    btn_mostraConfig.setLabel("Visualizza configurazione");
    btn_mostraConfig.setBounds(new Rectangle(5, 130, 170, 25));
    btn_mostraConfig.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_mostraConfig_actionPerformed(e);
      }
    });
    btn_ClearText.setActionCommand("clearText");
    btn_ClearText.setLabel("Pulisci messaggi");
    btn_ClearText.setBounds(new Rectangle(5, 155, 170, 25));
    btn_ClearText.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_ClearText_actionPerformed(e);
      }
    });
    fld_removeOrder.setBounds(new Rectangle(5, 190, 170, 20));  // Codice dell'ordine dal rimuovere
    fld_removeOrder.setText("Codice ordine");
    btn_removeOrder.setActionCommand("removeOrder");            // Rimuovi ordine
    btn_removeOrder.setLabel("Rimuovi Ordine");
    btn_removeOrder.setBounds(new Rectangle(5, 210, 170, 25));
    btn_removeOrder.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_removeOrder_actionPerformed(e);
      }
    });
    btn_close.setActionCommand("closeSession");
    btn_close.setLabel("Esci");
    btn_close.setBounds(new Rectangle(5, 260, 170, 30));
    btn_close.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_close_actionPerformed(e);
      }
    });
    msgBox.setBounds(new Rectangle(190, 5, 390, 285));
    label1.setFont(new java.awt.Font("Dialog", 1, 12));
    label1.setText("Cod  Modello                       Prezzo");
    label1.setBounds(new Rectangle(5, 294, 320, 15));
    listProd.setBounds(new Rectangle(5, 310, 300, 160));
    btn_addProd.setActionCommand("addProd");                   // Aggiunge un prodotto alla lista
    btn_addProd.setFont(new java.awt.Font("Dialog", 1, 14));
    btn_addProd.setLabel(">");
    btn_addProd.setBounds(new Rectangle(307, 330, 40, 25));
    btn_addProd.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_addProd_actionPerformed(e);
      }
    });
    quantita.setText("1");
    quantita.setBounds(new Rectangle(307, 356, 40, 25));
    btn_removeProd.setActionCommand("removeProd");                // Rimuove un ordine alla lista
    btn_removeProd.setFont(new java.awt.Font("Dialog", 1, 14));
    btn_removeProd.setLabel("<");
    btn_removeProd.setBounds(new Rectangle(307, 382, 40, 25));
    btn_removeProd.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_removeProd_actionPerformed(e);
      }
    });
    orderProd.setBounds(new Rectangle(350, 310, 230, 160));





    this.setBackground(Color.lightGray);
    this.add(btn_connect, null);
    this.add(bnt_deconnect, null);
    this.add(bnt_listProd, null);
    this.add(btn_sendOrder, null);
    this.add(btn_mostraConfig, null);
    this.add(btn_ClearText, null);
    this.add(fld_removeOrder, null);
    this.add(btn_removeOrder, null);
    this.add(msgBox, null);
    this.add(listProd, null);
    this.add(orderProd, null);
    this.add(btn_removeProd, null);
    this.add(btn_addProd, null);
    this.add(quantita, null);
    this.add(label1, null);
    this.add(btn_close, null);
  }
  /**Start the applet*/
  public void start() {
    caricaConfig();
  }
  /**Stop the applet*/
  public void stop() {
  }
  /**Destroy the applet*/
  public void destroy() {
  }
  /**Get Applet information*/
  public String getAppletInfo() {
    return "Applet Information";
  }
  /**Get parameter info*/
  public String[][] getParameterInfo() {
    return null;
  }
  /**Main method*/
  public static void main(String[] args) {
    Client applet = new Client();
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame() {
      protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
          System.exit(0);
        }
      }
      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
    };
    frame.setTitle("Gestione Ordini");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(595,505);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }
  /** Attiva la connessione al Server */
  void btn_connect_actionPerformed(ActionEvent e) {
    int i=0; // Contatore delle possibili connessioni effettuate
    boolean connect = false;
    while ((i<servListSize)&&!connect){
      try{
        //msgBox.append("1\n");
        cliSocket = new Socket(((serverInfo) serverList.get(i)).getAddr(),((serverInfo) serverList.get(i)).getPort());
        //msgBox.append("2\n");
        In = new BufferedReader(new InputStreamReader(cliSocket.getInputStream()));
        //msgBox.append("3\n");
        Out = new BufferedWriter(new OutputStreamWriter(cliSocket.getOutputStream()));
        //msgBox.append("4\n");
        msgBox.append("Connessione al Server completata\n");
        //msgBox.append("5\n");
        connect = true;
        //msgBox.append("1\n");
      }catch(Exception err){
        if (i<serverList.size()) {
          msgBox.append("Impossibile connettersi al "+Integer.toString(i)+" Server\n");
          i++;
        };
      };
    };  // La connessione  stata instaurata se si arriva a questo punto
    //msgBox.append("6\n");
    if (!connect){ msgBox.append("Impossibile instaurare la connessione, potrebbe dipendere da un problema locale\n"); return; };
    try {
      //msgBox.append("7\n");
      Out.write((new cliConnectMsg(CL,cliCode)).toMsg());
      //msgBox.append("8\n");
      Out.flush();
      //msgBox.append("9\n");
      Out.newLine();
      //msgBox.append("10\n");
      cliAckMsg ack = new cliAckMsg(In.readLine());
      //msgBox.append(ack.toMsg()+"\n");
      if (ack.getCl()!=CL) {  // occorre aggiornare le informazioni
        msgBox.append("Aggiornamento delle informazioni sul server in corso\n");
        CL = ack.getCl();
        for(int k=0;k<ack.getNumInfo();k++){
          serverList.add(k,extractServerListElem(ack.getInfo(k)));
        };
        servListSize = ack.getNumInfo();
      };
      //msgBox.append(ack.toMsg()+"\n");
    } catch(Exception err){ msgBox.append("Errore durante l'inizializzazione della connessione\n");};
  }

  void caricaConfig () { // Carica da disco i dati di configurazione
    try {
      serverList = new ArrayList(); // Creo la lista dei server disponibili
      msgBox.append("Avvio Carica Config\n");
      Reader r = new BufferedReader(new FileReader(stringCommand.CLIENT_CFG_FILE));
      StreamTokenizer st = new StreamTokenizer(r);
      st.commentChar('#');
      int tt = -4;  // Var. per memorizzare lo stato del tokenizer
      while (tt != StreamTokenizer.TT_EOF) {
        while ((tt != StreamTokenizer.TT_WORD)&&(tt != StreamTokenizer.TT_EOF)){ // per proseguire nell' analisi devo avere una word
          tt = st.nextToken();
        }
        if(tt == StreamTokenizer.TT_EOF) break; // Se sono alla fine dello stream esco dal ciclo
        if(st.sval.compareTo("SERVERADDR")==0) { // Lettura informazioni sui server
          st.nextToken();
          String servname = st.sval; // Appoggio per memorizzare il nome del server
          st.nextToken();
          String ip = st.sval; // Appoggio per memorizzare l'IP
          st.nextToken();
          int port = (int)st.nval; // Appoggio per memorizzare la porta
          serverList.add(new serverInfo(servname,ip,port));
          tt = st.nextToken();
          continue;
        };
        if(st.sval.compareTo("LOGICCLOCK")==0) { // Informazioni sul previous Server
          st.nextToken();
          CL = (long)st.nval; // Leggo il clock Logico
          tt = st.nextToken();
          continue;
        };
        if(st.sval.compareTo("CLIENTCODE")==0) { // Lettura informazioni sul codice del cliente
          st.nextToken();
          cliCode = st.sval; // Leggo il codice del cliente
          tt = st.nextToken();
          continue;
        };
        tt = st.nextToken();
      }
      msgBox.append("Lettura della configurazione da disco\n");
    }catch (Exception Err) { msgBox.append("Errore nella lettura della configurazione\n"); };
    servListSize = serverList.size();
    msgBox.append("Configurazione completata con successo\n");
  }

  void bnt_deconnect_actionPerformed(ActionEvent e) {
    try {
      //In.close();
      //Out.close();
      cliSocket.close();
      msgBox.append("Terminazione della connessione completata con successo\n");
   }catch(Exception err){ msgBox.append("Errore durante la terminazione della connessione\n"); };
  }

  void btn_mostraConfig_actionPerformed(ActionEvent e) {
    int i;
    msgBox.append("-------- CONFIGURAZIONE --------\n");
    msgBox.append("Clock Logico : "+Long.toString(CL)+"\n");
    msgBox.append("Codice Personale : "+cliCode+"\n");
    for (i=0;i<serverList.size();i++){
      msgBox.append(Integer.toString(i+1)+" Server  IP: "+((serverInfo) serverList.get(i)).getAddr()+" Porta: "+Integer.toString(((serverInfo) serverList.get(i)).getPort()));
      if(i<servListSize) msgBox.append(" Attivo\n");
      else msgBox.append(" Inattivo\n");
    };
    msgBox.append("--------------------------------\n");
  }
/** Si incarica di richiedere al server, qualora la connessione sia stata precedentemenete instaurata, la lista dei prodotti disponibili per l'acquisto.
 *  Quindi ne introduce i valori nella lista dei prodotti presente nell'interfaccia grafica  */
  void bnt_listProd_actionPerformed(ActionEvent e) {
    try {
      cliListProdReqMsg req = new cliListProdReqMsg(); // creo la classe di richiesta
      msgBox.append("INVIO: "+req.toMsg());
      Out.write(req.toMsg());  // e la spedisco al server
      Out.flush();
    }catch(Exception err){ msgBox.append("Errore durante l'inoltro della richiesta\n"); };
    try {
      cliListProdReplyMsg reply = new cliListProdReplyMsg(In.readLine()); // leggo la risposta
      listProd.removeAll();
      codeProduct = new ArrayList();
      numberProduct = new ArrayList();
      orderProd.removeAll();
      for (int i=0;i<reply.getNumProd();i++) {
        String app = reply.getProd(i);
        int pos = app.indexOf('|');
        app = app.substring(pos+1);
        //app = app.replace('|',' ');
        listProd.add(app); //.substring(reply.getProd(i).indexOf('|')));
        //msgBox.append(reply.getProd(i)+"\n");
      };
      msgBox.append("Lista dei prodotti caricata\n");
    }catch(Exception err){ msgBox.append("Errore durante la ricezione della risposta\n"); };

  }

  void btn_ClearText_actionPerformed(ActionEvent e) {
    msgBox.setText("");
  }

  void btn_addProd_actionPerformed(ActionEvent e) {
    try {
      if (listProd.getSelectedItem() != null) {
        numberProduct.add(quantita.getText());
        String app = listProd.getSelectedItem();
        int pos = app.indexOf('|');
        codeProduct.add(app.substring(0,pos));
        app = app.substring(pos+1);
        pos = app.indexOf('|');
        orderProd.add(quantita.getText()+" X "+app.substring(0,pos));
      };
    }catch (Exception Err) { msgBox.append("Errore nella selezione del prodotto\n"); };
  }

  void btn_removeProd_actionPerformed(ActionEvent e) {
    try {
      if (orderProd.getSelectedItem() != null) {
        numberProduct.remove(orderProd.getSelectedIndex());
        codeProduct.remove(orderProd.getSelectedIndex());
        orderProd.remove(orderProd.getSelectedIndex());
      };
    }catch (Exception Err) { msgBox.append("Errore nella selezione del prodotto\n"); };
  }

  void btn_sendOrder_actionPerformed(ActionEvent e) {
    boolean sending=false;
    cliSendOrderMsg req = new cliSendOrderMsg(cliCode,new ArrayList());
    try {
      if (orderProd.getItemCount()>0){
        for (int i=0;i<orderProd.getItemCount();i++){
          req.addInfo(((String)codeProduct.get(i)),((String)numberProduct.get(i)));
        };
        sending=true;
      }else{
        msgBox.append("Occorre selezionare almeno un prodotto\n");
      };
    }catch(Exception Err){ msgBox.append("Impossibile preparare l'ordine\n");};
    try {
      if (sending) {
        Out.write(req.toMsg());
        Out.flush();
        String app = In.readLine();
        cliAckOrderMsg result = new cliAckOrderMsg(app);
        switch (result.getResult()){
          case cliAckOrderMsg.ORDER_ACCEPT : {
            msgBox.append("L'ordinativo richiesto  stato accettato\nIl codice del suo ordine  :"+result.getOrderCode()+"\n");
          }; break;
          case cliAckOrderMsg.END_PRODUCT : {
            msgBox.append("Prodotti esauriti impossibile gestire l'ordine "+result.getOrderCode()+".\n");
          }; break;
          default :msgBox.append("Si  verificato un errore durante la procedura di richiesta, vi consigliamo di riprovare pi tardi\n"); break;
        };

      };
    }catch(Exception Err){ msgBox.append("Impossibile preparare l'ordine\n");};
  }

  void btn_removeOrder_actionPerformed(ActionEvent e) {
    cliDelOrderMsg req;
    try {
      if (fld_removeOrder.getText().compareTo("")!=0) {
        req = new cliDelOrderMsg(fld_removeOrder.getText(),this.cliCode);
        Out.write(req.toMsg());
        Out.flush();
        String app = In.readLine();
        cliAckOrderMsg result = new cliAckOrderMsg(app);
        switch (result.getResult()){
          case cliAckOrderMsg.ORDER_ACCEPT : {
            msgBox.append("L'ordine "+result.getOrderCode()+"  stato cancellato.\n");
          }; break;
          case cliAckOrderMsg.ERROR_ON_CODE : {
            msgBox.append("L'ordine "+result.getOrderCode()+" non esiste.\n");
          }; break;
          case cliAckOrderMsg.END_PRODUCT : {
            msgBox.append("Prodotti esauriti impossibile gestire l'ordine "+result.getOrderCode()+".\n");
          }; break;
          default :msgBox.append("Si  verificato un errore durante la procedura, vi consigliamo di riprovare pi tardi\n"); break;
        };
      }else{
        msgBox.append("Occorre specificare il codice dell'ordine.\n");
      };
    }catch(Exception Err){ msgBox.append("Impossibile rimuovere l'ordine\n");};
  }
  serverInfo extractServerListElem(String servname){
    for (int i=0;i<serverList.size();i++){
      if(servname.compareToIgnoreCase(((serverInfo)serverList.get(i)).getServName())==0)
        return ((serverInfo)serverList.remove(i));
    };
    return ((serverInfo)serverList.get(0));
  };

  void btn_close_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
} // End Class CLIENT

/** Consente di memorizzare le informazioni sui server disponibili */
class serverInfo {
  String servName;  // Nome del server
  String Addr;      // Indirizzo del server
  int Port;         // Porta del server

  serverInfo() {
    servName = new String("");
    Addr = new String("127.0.0.1");
    Port = 0;
  };
  serverInfo(String servname,String addr,int port){
    servName = servname;
    Addr = addr;
    Port = port;
  };
  int getPort() { return Port; };
  void setPort(int port) { Port = port; };
  String getAddr() { return Addr; };
  void setAddr(String addr) { Addr = addr; };
  void setServName(String servname) { servName = servname; };
  String getServName() { return servName; };
};