package reti;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.util.Hashtable;
import java.util.*;

/**
 * Title:        Progetto di reti di calcolatori
 * Description:  Sistema di server commerciali per la vendita di prodotti via internet
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Alessandro Celli
 * @version 1.0
 */

public class Server extends java.applet.Applet {
  // **************************** VARIABILI DI CONFIGURAZIONE ***************************
  boolean monoServer;  // Server unico o presenza di altre copie
  String servCode;     // codice univoco del server
  ArrayList servList;  // Informazioni sugli altri server
  short  servListPos;  // Posizione attuale nella scansione della servList
  long CL;             // Clock Logico del sistema
  boolean lastWinner;  // Specifica se il server ha vinto l'ultimo conflitto in cui ha partecipato
  database db;         // Oggetto delegato alla gestione del DataBase
  stringCommand command;// Istanza del file delle stringhe di comando
  boolean Crash = true; // permette di distinguere un caso di crash da uno di inserimento di un nuovo server
  static String Arg;    // Argomento passato dalla linea di comando
  // ********************************* VARIABILI DI RETE ********************************
  String ipNext;       // IP del server successivo
  String ipAddr;       // IP della macchina
  String ipPrev;       // IP del server precedente
  int portNext;        // Porta del server successivo
  int portCli;         // Porta per i clienti
  int portPrev;        // Porta per il previous server

  int portCliNext;     // Porta per i clienti del server successivo
  int portCliPrev;     // Porta per i clienti del server predecessore

  //PipedReader pnPipe;  // Pipeline per il dialogo tra i thread Previous IN --> Next OUT
  //PipedReader npPipe;  // Pipeline per il dialogo tra i thread Next IN --> Previous OUT

  // ******************************** THREAD DEL SISTEMA ********************************
  nextInThread   nextInThrd;   // Thread che gestisce l'input con il Next Server
  //nextOutThread  nextOutThrd;  // Thread che gestisce l'output con il Next Server
  prevInThread   prevInThrd;   // Thread che gestisce l'input con il Previous Server
//  prevOutThread  prevOutThrd;  // Thread che gestisce l'output con il Previous Server
  cliThread      cliThrd;      // Thread che gestisce le interazioni con i client
  cliAcceptThread cliAcceptThrd; // Thread che onsente l'innesco dei cliThread

  boolean nextConnection = false;   // Specifica se il nextServer  attivo
  boolean prevConnection = false;   // Specifica se il PrevServer  attivo

  Hashtable      clientOrder;   // Code che registra i client in attesa del completamento della registrazione di un ordine
  // ************************************ STREAM DATI ***********************************
  BufferedReader nextIn;    // Stream per la lettura dell'input dal Next Server
  BufferedWriter nextOut;   // Stream per la lettura dell'output dal Next Server
  BufferedReader prevIn;    // Stream per la lettura dell'input dal Previous Server
  BufferedWriter prevOut;   // Stream per la lettura dell'output dal Previous Server

  // ************************************** SOCKET **************************************
  Socket nextSocket;      // socket per i dialoghi con il server successivo
  Socket prevSocket;      // socket per i dialoghi con il server predecessore
  Socket cliSocket;       // socket er il dialogo con i clienti
  ServerSocket prevServSocket;// server socket per accettare il dialogo con il server predecessore
  ServerSocket cliServSocket;// server socket per accettare il dialogo con i clienti

  // ******************************** INTERFACCIA GRAFICA *******************************
  boolean isStandalone = true;
  Label label1 = new Label();
  Label lbl_ip = new Label();
  TextField textField4 = new TextField();
  Label lbl_next = new Label();
  Label lbl_prev = new Label();
  TextField textField1 = new TextField();
  TextField textField2 = new TextField();
  TextArea msgBox = new TextArea();
  Label label2 = new Label();
  Label label3 = new Label();
  TextField textField3 = new TextField();
  Button btn_test = new Button();
  Button btn_ClearText = new Button();
  Button btn_FlushDb = new Button();
  Button btn_showProdTable = new Button();
  Button btn_pendingProd = new Button();
  Button btn_cliOrder = new Button();
  Button btn_cliPendingOrder = new Button();
  Button btn_SystemState = new Button();
  Button btn_backtest = new Button();
  Button btn_close = new Button();


  /**Get a parameter value*/
  public String getParameter(String key, String def) {
    return isStandalone ? (Arg != null ? Arg : "1") :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  /** Costruttore della classe Server.\nNon compie nesuna operazione in quanto svolte dai metodi Init e Start*/
  public Server() {
  }
  /**Inizializza il server creando l'interfaccia grafica per gli utenti, parte di tale inizializzazione  delegata al metodo jbInit().*/
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception {
    this.setLayout(null);
    label1.setFont(new java.awt.Font("Dialog", 1, 18));  // Label del titolo
    label1.setText("Panello di Controllo");
    label1.setBounds(new Rectangle(236, 3, 179, 25));
    label2.setFont(new java.awt.Font("Dialog", 1, 13));  // Label dell'IP
    label2.setText("IP");
    label2.setBounds(new Rectangle(5, 45, 35, 20));
    label3.setFont(new java.awt.Font("Dialog", 1, 13));  // Label della Porta
    label3.setText("Port");
    label3.setBounds(new Rectangle(5, 65, 35, 20));
    textField4.setFont(new java.awt.Font("Dialog", 1, 13));  // Text del IP
    textField4.setText("IP");
    textField4.setBounds(new Rectangle(40, 45, 100, 20));
    textField3.setText("Porta");                              // Text della porta
    textField3.setBounds(new Rectangle(40, 65, 100, 20));
    lbl_next.setFont(new java.awt.Font("Dialog", 1, 13));    // Label del Next
    lbl_next.setText("Next");
    lbl_next.setBounds(new Rectangle(5, 85, 35, 20));
    lbl_prev.setFont(new java.awt.Font("Dialog", 1, 13));  // Label del previous
    lbl_prev.setText("Prev");
    lbl_prev.setBounds(new Rectangle(5, 105, 35, 20));
    textField1.setText("Next");                            // Text del Next
    textField1.setBounds(new Rectangle(40, 85, 100, 20));
    textField2.setText("Previous");                      // Text del Previous
    textField2.setBounds(new Rectangle(40, 105, 100, 20));
    btn_test.setActionCommand("test");
    btn_test.setLabel("Test in Avanti");                  //  Test in avanti
    btn_test.setBounds(new Rectangle(5, 135, 135, 25));
    btn_test.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_test_actionPerformed(e);
      }
    });
    btn_backtest.setActionCommand("backtest");          // Test indietro
    btn_backtest.setLabel("Test indietro");
    btn_backtest.setBounds(new Rectangle(5, 160, 135, 25));
    btn_backtest.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_backtest_actionPerformed(e);
      }
    });
    btn_ClearText.setActionCommand("ClearText");            // Pulisci messaggi
    btn_ClearText.setLabel("Pulisci Messaggi");
    btn_ClearText.setBounds(new Rectangle(5, 195, 135, 25));
    btn_ClearText.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_ClearText_actionPerformed(e);
      }
    });
    btn_SystemState.setActionCommand("systemState");       // Stato del sistema
    btn_SystemState.setLabel("Stato del Sistema");
    btn_SystemState.setBounds(new Rectangle(5, 220, 135, 25));
    btn_SystemState.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_SystemState_actionPerformed(e);
      }
    });
    btn_FlushDb.setActionCommand("flushDb");      // Memorizza Database
    btn_FlushDb.setLabel("Memorizza Database");
    btn_FlushDb.setBounds(new Rectangle(5, 255, 135, 25));
    btn_FlushDb.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_FlushDb_actionPerformed(e);
      }
    });
    btn_showProdTable.setActionCommand("showProdTable");   //  Prodotti disponibili
    btn_showProdTable.setLabel("Prodotti disponibili");
    btn_showProdTable.setBounds(new Rectangle(5, 300, 135, 25));
    btn_showProdTable.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_showProdTable_actionPerformed(e);
      }
    });
    btn_cliOrder.setActionCommand("cliOrder");         // Ordini Ricevuti
    btn_cliOrder.setLabel("Ordini ricevuti");
    btn_cliOrder.setBounds(new Rectangle(5, 325, 135, 25));
    btn_cliOrder.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_cliOrder_actionPerformed(e);
      }
    });
    btn_pendingProd.setActionCommand("pendingProd");     // Prodotti pendenti
    btn_pendingProd.setLabel("Prodotti pendenti");
    btn_pendingProd.setBounds(new Rectangle(5, 355, 135, 25));
    btn_pendingProd.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_pendingProd_actionPerformed(e);
      }
    });
    btn_cliPendingOrder.setActionCommand("cliPendingOrder");  // Ordini pendenti
    btn_cliPendingOrder.setLabel("Ordini pendenti");
    btn_cliPendingOrder.setBounds(new Rectangle(5, 380, 135, 25));
    btn_cliPendingOrder.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_cliPendingOrder_actionPerformed(e);
      }
    });
    btn_close.setActionCommand("closeSession");            // Chiusura del programma
    btn_close.setLabel("Esci");
    btn_close.setBounds(new Rectangle(5, 440, 135, 30));
    btn_close.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btn_close_actionPerformed(e);
      }
    });

    msgBox.setText("");
    msgBox.setBounds(new Rectangle(145, 35, 385, 435));


    this.setBackground(Color.lightGray);
    this.add(lbl_ip, null);
    this.add(msgBox, null);
    this.add(textField4, null);
    this.add(label2, null);
    this.add(textField2, null);
    this.add(lbl_next, null);
    this.add(textField1, null);
    this.add(lbl_prev, null);
    this.add(label3, null);
    this.add(textField3, null);
    this.add(btn_test, null);
    this.add(btn_showProdTable, null);
    this.add(btn_pendingProd, null);
    this.add(btn_cliOrder, null);
    this.add(btn_cliPendingOrder, null);
    this.add(btn_backtest, null);
    this.add(btn_SystemState, null);
    this.add(label1, null);
    this.add(btn_ClearText, null);
    this.add(btn_FlushDb, null);
    this.add(btn_close, null);
  }
  /** Si incarica di inizializzare tutte le funzionalit del server e di attivare i thread che consentiranno la gestione delle operazioni. */
  public void start() {
    servList = new ArrayList();
    servListPos = 0;
    clientOrder = new Hashtable();
    command = new stringCommand(Short.parseShort(this.getParameter("SERVER","1")));
    //command = new stringCommand();
    msgBox.append("Avvio del server in corso\n");
    caricaConfig(); // Carica la configurazione del server
    addServList(getServCode());   // Aggiunge se stesso alla lista dei server disponibili
    activateConnection();
  }

  void activateConnection(){
    BufferedReader cliIn;
    BufferedWriter cliOut;
    cliServAckMsg reply;
    if (!monoServer) { // Se esistono gi dei server attivi ( almeno uno )
      try {  // Richiedo l'attivazione al nextServer della porta per l'aggiornamento del DB
        //npPipe = new PipedReader(); // Creo le Pipe per la comunicazione fra thread
        //pnPipe = new PipedReader();
        cliSocket = new Socket(ipNext,portCliNext);
        //msgBox("1\n");
        cliIn = new BufferedReader(new InputStreamReader(cliSocket.getInputStream()));
        cliOut = new BufferedWriter(new OutputStreamWriter(cliSocket.getOutputStream()));
        cliAcceptNewServerMsg req = new cliAcceptNewServerMsg();
        req.setIp(ipPrev);
        req.setPort(portPrev);
        req.setServCode(servCode); // Imposto il mio codice di server
        cliOut.write(req.toMsg());
        cliOut.flush();
        reply = new cliServAckMsg(cliIn.readLine());
        for(int k=0;k<reply.getNumInfo();k++) {
          if (!servList.contains(reply.getInfo(k))) addServList(reply.getInfo(k));
        };
        if (!servList.contains(reply.getServCode())) addServList(reply.getServCode());  // Aggiungo un nuovo server alla server list
        resetServListPos();            // e resetto il contatore relativo
        setCl(reply.getCl());               // infine imposto il clock logico
        caricaDatabase(cliIn,cliOut);
        cliIn.readLine(); // Attendo la sincronizzazione dal Generic Ack
        //msgBox.append("AAA");
        for(int k=0;k<10000;k++){ };
      }catch(Exception e){
        reply = new cliServAckMsg();
        msgBox.append("Impossibile connettersi al Next Server\n");
        return;
      };  // Il protocollo di accettazione  concluso, quindi si instaura una nuova connessione per il server che si aggiunge alla rete
      if(!reply.isAccept()) {
        msgBox.append("Il Next Server rifiuta la connessione\n");
      }else{
        try {  //Apro il dialogo con il nextServer
          nextSocket = new Socket(ipNext,portNext);
          nextIn = new BufferedReader(new InputStreamReader(nextSocket.getInputStream()));
          nextOut = new BufferedWriter(new OutputStreamWriter(nextSocket.getOutputStream()));
          nextInThrd = new nextInThread(nextIn,null,this);  // Preparo ed attivo il thread per la gestione del Next In
          nextInThrd.start();
//          nextOutThrd = new nextOutThread(nextOut,pnPipe,this);  // Preparo ed attivo il thread per la gestione del Next Out
//          nextOutThrd.start();
        }catch(Exception e){ msgBox.append("Impossibile connettersi al Next Server\n"); };
        try {  //Apro il dialogo con il prevServer
          prevServSocket = new ServerSocket(portPrev); // Creo la server socket per accettare il dialogo con il predecessore
          cliOut.write((new genericAckMsg()).toMsg());
          cliOut.flush();
          prevSocket = prevServSocket.accept();  // accetto l'aggancio al previous server
 //         cliIn.readLine();
          prevIn = new BufferedReader(new InputStreamReader(prevSocket.getInputStream()));
          prevOut = new BufferedWriter(new OutputStreamWriter(prevSocket.getOutputStream()));
          prevInThrd = new prevInThread(prevIn,null,this);   // Preparo ed attivo il thread per la gestione del Prev In
          prevInThrd.start();
//          prevOutThrd = new prevOutThread(prevOut,npPipe,this);   // Preparo ed attivo il thread per la gestione del Prev In
//          prevOutThrd.start();
          cliIn.readLine();
          cliIn.close();
          cliOut.close();
          cliSocket.close();
          // AGGIORNAMENTO DEL CLOCK LOGICO E DELLE INFO PER I CLIENT
          // se ne deve forzare l'aggiornamento per gli altri server
        }catch(Exception e){ msgBox.append("Impossibile connettersi al Previous Server\n"); };
      };
    } else { // ELSE per il caso monoserver ..... *******************************************
      caricaDatabase(); // Utilizzo il DB locale come unica fonte dei dati
    };
    try {  // attivo l'accettazione dei clienti
      //msgBox.append("AAAAAAAAAA\n");
      cliServSocket = new ServerSocket(portCli); // Creo la server socket per accettare i clienti
      textField3.setText(Integer.toString(portCli));
      textField4.setText(cliServSocket.getInetAddress().getLocalHost().getHostAddress());
/*      while(true){  <------- CANCELLATO PER NON BLOCCARE IL RUN-TIME !!!!!!!!!!!!!!
        cliSocket = cliServSocket.accept();  // accetto i clienti che si collegano
        cliThrd = new cliThread(cliSocket,this); // passo la socket e il riferimento al server per il dialogo con gli altri thread
        cliThrd.start();
//        cliSocket.close();
      };*/
      cliAcceptThrd = new cliAcceptThread(cliServSocket,this);
      cliAcceptThrd.start();
      msgBox.append("Server pronto per l'accettazione dei clienti\n");
    }catch(Exception e){ msgBox.append("Impossibile accettare la connessione dei Clienti\n"); };

  };

  boolean closeAllConnection(){
    boolean res = true;
//    nextInThrd.
//    nextOutThrd.stop();
//    prevInThrd.stop();
//    prevOutThrd.stop();
//    cliThrd.destroy();
    try { nextIn.close();    } catch(Exception err){ msgBox.append("Errore nella chiusura del buffer nextIn");  res=false; };
    try { nextOut.close();   } catch(Exception err){ msgBox.append("Errore nella chiusura del buffer nextOut"); res=false; };
    try { prevIn.close();    } catch(Exception err){ msgBox.append("Errore nella chiusura del buffer prevIn");  res=false; };
    try { prevOut.close();   } catch(Exception err){ msgBox.append("Errore nella chiusura del buffer prevOut"); res=false; };
    try { nextSocket.close();} catch(Exception err){ msgBox.append("Errore nella chiusura della Socket Next");  res=false; };
    try { prevSocket.close();} catch(Exception err){ msgBox.append("Errore nella chiusura della Socket Prev");  res=false; };
    try { cliSocket.close(); } catch(Exception err){ msgBox.append("Errore nella chiusura della Socket Client");res=false; };
    try { cliServSocket.close(); } catch(Exception err){ msgBox.append("Errore nella chiusura della Socket Server Client"); res=false; };
    try { prevServSocket.close();} catch(Exception err){ msgBox.append("Errore nella chiusura della Socket Server Prev");   res=false; };
    return res;
  };

  boolean closeNextConnection(){
    boolean res = true;
    try { nextIn.close();    } catch(Exception err){ msgBox.append("Errore nella chiusura del buffer nextIn");  res=false; };
    try { nextOut.close();   } catch(Exception err){ msgBox.append("Errore nella chiusura del buffer nextOut"); res=false; };
    try { nextSocket.close();} catch(Exception err){ msgBox.append("Errore nella chiusura della Socket Next");  res=false; };
    return res;
  };

  boolean closePrevConnection(){
    boolean res = true;
    try { prevIn.close();    } catch(Exception err){ msgBox.append("Errore nella chiusura del buffer prevIn");  res=false; };
    try { prevOut.close();   } catch(Exception err){ msgBox.append("Errore nella chiusura del buffer prevOut"); res=false; };
    try { prevSocket.close();} catch(Exception err){ msgBox.append("Errore nella chiusura della Socket Prev");  res=false; };
    try { prevServSocket.close();} catch(Exception err){ msgBox.append("Errore nella chiusura della Socket Server Prev");   res=false; };
    return res;
  };

  /**Stop the applet*/
  public void stop() {
  }
  /**Destroy the applet*/
  public void destroy() {
  }
  /**Get Applet information*/
  public String getAppletInfo() {
    return "Applet Information";
  }
  /**Get parameter info*/
  public String[][] getParameterInfo() {
    return null;
  }
  String getServCode(){ return servCode; }

  /** Fornisce le funzionalit per eseguire il server come applicazione Stand-alone. */
  public static void main(String[] args) {
    if (args.length==1) {
      Arg = args[0]; // Leggo l'argomento passato dalla linea di comando
    } else {
      System.out.println("Errore di Sintassi !\nUsare : reti.Server <opzione>\nDove opzione puo' essere 1 , 2 o 3\n");
      System.exit(0);
    };
    Server applet = new Server();
    //applet.configFile = Short.parseShort(args[0]);
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame() {
      protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
          System.exit(0);
        }
      }
      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
    };
    frame.setTitle("Server - Pannello di controllo");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(550,510);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

  void btn_closeComm_actionPerformed(ActionEvent e) {
    if(closeAllConnection()) msgBox.append("Chiusura dei canali di comunicazione effettuata con successo");
    else msgBox.append("Errore durante la chiusura dei canali di comunicazione");
  }

  public void caricaConfig () { // Carica da disco i dati di configurazione
    try {
      msgBox.append("Avvio Carica Config\n");
      Reader r = new BufferedReader(new FileReader(command.SERVER_CFG_FILE));
/*      if (configFile==2) r = new BufferedReader(new FileReader(command.SERVER_CFG_FILE_2));
      else r = new BufferedReader(new FileReader(command.SERVER_CFG_FILE));*/
      StreamTokenizer st = new StreamTokenizer(r);
      st.commentChar('#');
      int tt = -4;
      while (tt != StreamTokenizer.TT_EOF) {
        while ((tt != StreamTokenizer.TT_WORD)&&(tt != StreamTokenizer.TT_EOF)){ // per proseguire nell' analisi devo avere una word
          tt = st.nextToken();
        }
        if(tt == StreamTokenizer.TT_EOF) break; // Se sono alla fine dello stream esco dal ciclo
        if(st.sval.compareTo("MONOSERVER")==0){ // Verifico se  il primo server della rete
          st.nextToken();
          monoServer = st.sval.equalsIgnoreCase("yes") ? true : false;
        };
        if(st.sval.compareTo("NEXTSERVER")==0) { // Informazioni sul next Server
          st.nextToken();
          ipNext = st.sval; //.substring(1,st.sval.length()-1);  // Leggo l'ip
          st.nextToken();
          portNext = (int)st.nval; // Leggo la porta
          textField1.setText(ipNext+":"+Integer.toString(portNext));
          tt = st.nextToken();
          continue;
        };
        if(st.sval.compareTo("PREVSERVER")==0) { // Informazioni sul previous Server
          st.nextToken();
          ipPrev = st.sval; //.substring(1,st.sval.length()-1);  // Leggo l'ip
          st.nextToken();
          portPrev = (int)st.nval; // Leggo la porta
          textField2.setText(ipPrev+":"+Integer.toString(portPrev));
          tt = st.nextToken();
          continue;
        };
        if(st.sval.compareTo("CLIENTPORT")==0) { // Informazioni sulla porta per i clienti
          st.nextToken();
          portCli = (int)st.nval; // Leggo la porta
          tt = st.nextToken();
          continue;
        };
        if(st.sval.compareTo("NEXTSERVERCLIENTPORT")==0) { // Informazioni sulla porta per i clienti del nextServer
          st.nextToken();
          portCliNext = (int)st.nval; // Leggo la porta
          tt = st.nextToken();
          continue;
        };
        if(st.sval.compareTo("PREVSERVERCLIENTPORT")==0) { // Informazioni sulla porta per i clienti
          st.nextToken();
          portCliPrev = (int)st.nval; // Leggo la porta
          tt = st.nextToken();
          continue;
        };
        if(st.sval.compareTo("LOGICCLOCK")==0) { // Informazioni sul clock Logico
          st.nextToken();
          CL = (long)st.nval; // Leggo il clock Logico
          tt = st.nextToken();
          continue;
        };
        if(st.sval.compareTo("SERVERCODE")==0) { // Codice del server
          st.nextToken();
          servCode = st.sval; // Leggo il codice del server
          tt = st.nextToken();
          continue;
        };
        tt = st.nextToken();
      }
      msgBox.append("Lettura della configurazione da disco\n");
    }catch (Exception Err) { msgBox.append("Errore nella lettura della configurazione\n"); };
    msgBox.append("Configurazione completata con successo\n");
  }

/*  public void creaTabellaOrdini() {
    ordiniPendenti = new Hashtable();
  }*/
  /** Consente di caricare le informazioni del database sincronizzandole con quelle degli altri server */
  public void caricaDatabase(BufferedReader in,BufferedWriter out) {
    try {
      db = new database();
      msgBox.append("Trasferimento Database in corso\n");
      db.updateDb(in,command.PROD_DB_FILE);
      db.updateOrderDb(in,command.ORDER_DB_FILE);
      db.initDb(command.PROD_DB_FILE,command.ORDER_DB_FILE);
      msgBox.append("Database inizializzato correttamente\n");
    } catch(Exception ec){ msgBox.append("Errore durante l'inizializzazione del database\n");};
  }
  public void caricaDatabase() {
    try {
      db = new database();
      db.initDb(command.PROD_DB_FILE,command.ORDER_DB_FILE);
      msgBox.append("Database locale inizializzato correttamente\n");
    } catch(Exception ec){ msgBox.append("Errore durante l'inizializzazione del database\n");};
  }
  public long getCl() { return CL; };

  boolean newPrevServer(String newServer,int port,BufferedWriter out) {
    try {
      if (!monoServer) {
        msgBox.append("1\n");
//        prevOutThrd.sendNewServerMsg(); // inoltro un nuovo pachetto per segnalare la presenza del nuovo server
        sendPrevMsg(new servNewNextServerMsg(getServCode(),newServer,port,getCl()));
        msgBox.append("2\n");
 //       nextOutThrd.sendNewServerMsg();
 //       prevInThrd.destroy();
 //       prevOutThrd.destroy();
 //       prevIn.close();     // Chiudo la socket con il Previous server per far posto al nuovo
 //       prevOut.close();
        resetCrash();
        msgBox.append("3\n");
        prevSocket.close();
        msgBox.append("4\n");
        prevServSocket.close();
        msgBox.append("5\n");
        msgBox.append("Thread previous terminati");
      };
//      npPipe = new PipedReader();
//      pnPipe = new PipedReader();
      prevServSocket = new ServerSocket(portPrev); // Creo la server socket per accettare il dialogo con il predecessore
      msgBox.append("previous server socket "+prevServSocket.getInetAddress().getHostAddress()+" : "+Integer.toString(prevServSocket.getLocalPort())+"\n");
      out.write((new genericAckMsg()).toMsg());
      out.flush();
      prevSocket = prevServSocket.accept();  // accetto l'aggancio al previous server
      msgBox.append("previous socket "+prevSocket.getInetAddress().getHostAddress()+" : "+Integer.toString(prevSocket.getLocalPort()));
      prevIn = new BufferedReader(new InputStreamReader(prevSocket.getInputStream()));
      prevOut = new BufferedWriter(new OutputStreamWriter(prevSocket.getOutputStream()));
      prevInThrd = new prevInThread(prevIn,null,this);   // Preparo ed attivo il thread per la gestione del Prev In
      prevInThrd.start();
//      prevOutThrd = new prevOutThread(prevOut,null,this);   // Preparo ed attivo il thread per la gestione del Prev In
//      prevOutThrd.start();
      textField1.setText(ipNext+":"+Integer.toString(prevSocket.getPort()));
      return true;
    }catch(Exception Err){
      msgBox.append("Impossibile inizializzare i Previous Thread\n");
      return false;
    };
  };

  boolean recoveryPrevServer() {
    try {
      if (!monoServer) {
        prevSocket.close();
        prevServSocket.close();
        msgBox.append("Thread previous terminati");
      };
      prevServSocket = new ServerSocket(portPrev); // Creo la server socket per accettare il dialogo con il predecessore
      prevSocket = prevServSocket.accept();  // accetto l'aggancio al previous server
      prevIn = new BufferedReader(new InputStreamReader(prevSocket.getInputStream()));
      prevOut = new BufferedWriter(new OutputStreamWriter(prevSocket.getOutputStream()));
      prevInThrd = new prevInThread(prevIn,null,this);   // Preparo ed attivo il thread per la gestione del Prev In
      prevInThrd.start();
      textField1.setText(ipNext+":"+Integer.toString(prevSocket.getPort()));
      return true;
    }catch(Exception Err){
      msgBox.append("Impossibile inizializzare i Previous Thread\n");
      return false;
    };
  };


  boolean newNextServer(String newServer,int port) {
    try {
        ipNext = newServer;
        portNext = port;
        msgBox.append("Nuovo next Server : "+ipNext+":"+Integer.toString(port)+"\n");
        // VANNO RISETTATE LE LABEL !!!!!
        nextSocket = new Socket(ipNext,portNext);
        msgBox.append("next socket "+nextSocket.getInetAddress().getHostAddress()+" : "+Integer.toString(nextSocket.getLocalPort())+"\n");
        nextIn = new BufferedReader(new InputStreamReader(nextSocket.getInputStream()));
        nextOut = new BufferedWriter(new OutputStreamWriter(nextSocket.getOutputStream()));
        nextInThrd = new nextInThread(nextIn,null,this);   // Preparo ed attivo il thread per la gestione del Prev In
        nextInThrd.start();
        textField1.setText(ipNext+":"+Integer.toString(nextSocket.getPort()));
//        nextOutThrd = new nextOutThread(nextOut,null,this);   // Preparo ed attivo il thread per la gestione del Prev In
//        nextOutThrd.start();
        //monoServer = false;
        return true;
    }catch(Exception Err){
      msgBox.append("Impossibile inizializzare il nuovo server\n");
      return false;
    };
  };

  void btn_test_actionPerformed(ActionEvent e) {
    try{
      if (!monoServer){
        sendNextMsg(new servTestMsg(servCode,null));
      } else {
        msgBox.append("Il server locale  l'unico attivo\n");
      };
    }catch(Exception Err){
      msgBox.append("Errore - impossibile eseguire il test\n");
    };
  }

  void btn_ClearText_actionPerformed(ActionEvent e) {
    msgBox.setText("");
  }

  boolean registerClient(String orderCode,cliThread clithrd){
    clientOrder.put(orderCode,clithrd);
    return true;
  };

  boolean unRegisterClient(String orderCode){ return unRegisterClient(orderCode,cliAckOrderMsg.ORDER_ACCEPT);};
  boolean unRegisterClient(String orderCode, short result){
    try {
      for (Enumeration e = clientOrder.keys(); e.hasMoreElements();) {
        msgBox.append("In tab:"+(String)e.nextElement()+" cercato: "+orderCode+"\n");
      };
      //msgBox.append("201\n");
      cliThread th = (cliThread)clientOrder.remove(orderCode);
      //msgBox.append("202\n");
      if(th==null) msgBox.append("Thread non trovato\n");
      else {
        //msgBox.append("203"+th.toString()+"\n");
        th.cliAckOrder(result,orderCode);
      };

    }catch(Exception err){ msgBox.append("Errore nel invio del acknowledge al cliente\n"); return false; }
    //.cliAckOrder(orderCode);
    return true;
  };

  boolean unRegisterAllClient(){
    String orderCode;
    try {
      for (Enumeration e = clientOrder.keys(); e.hasMoreElements();) {
        orderCode = (String)e.nextElement();
        cliThread th = (cliThread)clientOrder.get(orderCode);
        if(th==null) msgBox.append("Thread non trovato\n");
        else {
          th.cliAckOrder(cliAckOrderMsg.SOCKET_BROKE,orderCode); // informo il client del fallimento e
          sendNextMsg(new servDelOrderMsg(this.getServCode(),orderCode,th.getCliCode())); // inoltro la richiesta di cancellazione del messaggio
        };
      };
      clientOrder.clear();
    }catch(Exception err){ msgBox.append("Errore nel invio del acknowledge al cliente\n"); return false; }
    return true;
  };

  int getWeight() {
    if (lastWinner) return Integer.parseInt(servCode.substring(2));
    else return (100 + Integer.parseInt(servCode.substring(2)));
  }

  void btn_showProdTable_actionPerformed(ActionEvent e) {
    msgBox.append("----- PRODOTTI DISPONIBILI -----\n");
    msgBox.append(db.getProdTable());
    msgBox.append("-------------------------------\n");
  }

  void btn_pendingProd_actionPerformed(ActionEvent e) {
    msgBox.append("----- PRODOTTI PENDENTI -----\n");
    msgBox.append(db.getProdPendingTable());
    msgBox.append("-------------------------------\n");
  }

  void btn_cliOrder_actionPerformed(ActionEvent e) {
    msgBox.append("----- ORDINI RICEVUTI -----\n");
    msgBox.append(db.getOrderTable());
    msgBox.append("-------------------------------\n");
  }

  void btn_cliPendingOrder_actionPerformed(ActionEvent e) {
    msgBox.append("----- ORDINI PENDENTI -----\n");
    msgBox.append(db.getPendingTable());
    msgBox.append("-------------------------------\n");
  }

  void btn_openComm_actionPerformed(ActionEvent e) {
    caricaConfig();
    activateConnection();
  }

  void btn_FlushDb_actionPerformed(ActionEvent e) {
    try {
      db.flushDb(command.PROD_DB_FILE);
      msgBox.append("DataBase memorizzato correttamente\n");
    }catch(Exception err){
      msgBox.append("Impossibile memorizzare il DataBase\n");
    };
  }

  void sendPrevMsg(servMsg msg) throws Exception {
    prevOut.write(msg.toMsg());
    prevOut.flush();
  };
  void sendNextMsg(servMsg msg) throws Exception {
    nextOut.write(msg.toMsg());
    nextOut.flush();
  };

  long incCl(){
    CL++;
    return CL;
  };
  void setCl(long cl) { CL = cl; };

  String getElemServList(){
    String result = (String)servList.get(servListPos);
    servListPos++;
    if (servListPos>=servList.size()) servListPos=0;
    return result;
  };
  void resetServListPos(){ servListPos=0; };

  void addServList(String servname){
    boolean end=false;
    int cont = 0;
    while((!end)&&(cont<servList.size())){
      //if (((String)servList.get(cont)).compareToIgnoreCase(servname)==0){ // Il server  gi registrato
      //};
      if (((String)servList.get(cont)).compareToIgnoreCase(servname)>0){// devo inserire il nuovo server in questa posizione
        servList.add(cont,servname);
        end = true;
      };
      cont++;
    };
    if (!end) servList.add(servname); // se non ho ancora inserito il nuovo elemento l'aggiungo in coda
  };

  void setPrevConnection()  { prevConnection = true; };
  void setNextConnection()  { nextConnection = true; };
  void resetPrevConnection(){ prevConnection = false;};
  void resetNextConnection(){ nextConnection = false;};
  boolean isSetPrevConnection()  { return prevConnection; };
  boolean isSetNextConnection()  { return nextConnection; };

  void btn_SystemState_actionPerformed(ActionEvent e) {
    msgBox.append("---------- STATO DEL SISTEMA ----------\n");
    try{
      if (monoServer) msgBox.append("Il sistema ha un solo server attivo\n");
      else msgBox.append("Nel sistema sono attivi pi server\n");
      msgBox.append("Server corrente : "+getServCode()+"\n");
      for (int k=0;k<servList.size();k++) msgBox.append("Server "+Integer.toString(k+1)+" : "+((String)servList.get(k))+"\n");
      msgBox.append("Clock Logico : "+Long.toString(getCl())+"\n");
      if (isSetNextConnection()) msgBox.append("Thread Next Attivo\n");
      if (isSetPrevConnection()) msgBox.append("Thread Previous Attivo\n");
      if (lastWinner) msgBox.append("Il server ha vinto l'ultimo conflitto a cui ha partecipato\n");
      else msgBox.append("Il server ha perso l'ultimo conflitto a cui ha partecipato\n");
    }catch(Exception err){ msgBox.append("Si  verificato un errore nell'esecuzione del test\n"); };
    msgBox.append("---------------------------------------\n");
  }

  void btn_backtest_actionPerformed(ActionEvent e) {
    try{
      if (!monoServer){
        sendPrevMsg(new servTestMsg(servCode,null));
      } else {
        msgBox.append("Il server locale  l'unico attivo\n");
      };
    }catch(Exception Err){
      msgBox.append("Errore - impossibile eseguire il test\n");
    };

  }

  void resetCrash(){ Crash = false;};
  void setCrash()  { Crash = true; };
  boolean isCrash(){ return Crash; };

  void btn_close_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

};


class cliAcceptThread extends Thread {
  ServerSocket cliServSocket;
  Socket       cliSocket;
  cliThread    cliThrd;
  Server       serv;

  cliAcceptThread(ServerSocket servsock,Server serv){ cliServSocket = servsock; this.serv = serv; };
  public void run() {
    try{
      while(true){
        cliSocket = cliServSocket.accept();  // accetto i clienti che si collegano
        cliThrd = new cliThread(cliSocket,serv); // passo la socket e il riferimento al server per il dialogo con gli altri thread
        cliThrd.start();
      };
    }catch(Exception err){ serv.msgBox.append("Impossibile accettare la connessione dei Clienti\n"); };
  };
};  // End CLASS : cliAcceptThread





