package reti;


import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.util.Hashtable;
import java.util.*;

/**
 * Title:        Progetto di reti di calcolatori
 * Description:  Sistema di server commerciali per la vendita di prodotti via internet
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Alessandro Celli
 * @version 1.0
 */
/** Si incarica di gestire l'interazione con uno specifico cliente.
 *  Riceve dal thread principale la socket per la gestione dell'interazione */
class cliThread extends Thread {
  Socket cliSocket;  // Socket per il dialogo con i clienti
  Server serv; // usato per riferire l'istanza del server
  BufferedReader clin;    // Flussi di Input Output per la socket
  BufferedWriter clout;
  String in;
  String cliCode;
  cliThread(Socket clisok,Server Serv){ cliSocket = clisok;   serv = Serv; };
  public void run(){
    short opcode=0;
    try{
      clin = new BufferedReader(new InputStreamReader(cliSocket.getInputStream()));
      clout = new BufferedWriter(new OutputStreamWriter(cliSocket.getOutputStream()));
      serv.msgBox.append("Nuovo client connesso\n");
      //serv.msgBox.append(clin.readLine());
      while(true) {
        // serv.msgBox.append("1\n");
        do {
//          do {
            in=clin.readLine();
            serv.msgBox.append("RICEVUTO CLI:"+in+"\n");
//          } while (in==null);
        } while (in.compareToIgnoreCase("")==0);
        opcode = Msg.getOpCode(in);
        switch (opcode){
          case stringCommand.CLI_CONNECT_CODE : {
            cliConnectMsg recv = new cliConnectMsg(in);
            cliCode = recv.getCliCode();
            cliAckMsg reply = new cliAckMsg(serv.getCl(),recv.getCliCode(),null);
            serv.msgBox.append("ack creato\n");
            if (recv.getCl()!= serv.getCl()) { //  necessario aggiornare le info sul sistema
              serv.msgBox.append("Stato del cliente aggiornato\n");
              for (int k=0;k<serv.servList.size();k++){
                //serv.msgBox.append(Integer.toString(k)+"\n");
                reply.addInfo((String)serv.servList.get(((k+serv.servListPos)%serv.servList.size())));
              };
              serv.servListPos++; // Incremento la posizione iniziale della servList
              if (serv.servList.size()<=serv.servListPos) serv.resetServListPos();
            }else{
            };
            //serv.msgBox.append("3\n");
            clout.write(reply.toMsg());
            clout.flush();
            serv.msgBox.append("ack inviato\n");
          }; break;
          case stringCommand.CLI_LIST_PROD_REQ_CODE : {
            cliListProdReqMsg   recv  = new cliListProdReqMsg(in);
            cliListProdReplyMsg reply = new cliListProdReplyMsg();
            serv.msgBox.append("lista prodotti inizializzata\n");
            reply.setProd(serv.db.readProdDB());
            clout.write(reply.toMsg());
            clout.flush();
            serv.msgBox.append("lista dei prodotti inviata\n");
          }; break;
          case stringCommand.CLI_SEND_ORDER_CODE : {
            cliSendOrderMsg recv  = new cliSendOrderMsg(in);
            //serv.msgBox.append(recv.toMsg()+"\n");
            if (serv.monoServer){ // Se il server  uno solo non si utilizza il supporto per gli ordini pendenti
              try{
                if(serv.db.checkOrder(recv)){ // L'ordine pu essere servito
                  orderElem order = new orderElem(serv.db.getOrderCode(serv.servCode),recv.getCliCode(),recv.getAllInfo());
                  serv.db.registerOrder(order); // l'ordine viene registrato nel database
                  cliAckOrderMsg reply = new cliAckOrderMsg(order.getOrderCode(),serv.servCode,recv.getCliCode(),cliAckOrderMsg.ORDER_ACCEPT);
                  clout.write(reply.toMsg());
                  clout.flush();
                  serv.msgBox.append("Registrato l'ordine "+order.getOrderCode()+"\n");
                }else{ // L'ordine non pu essere servito
                  cliAckOrderMsg reply = new cliAckOrderMsg(cliAckOrderMsg.NO_ORDER_CODE,serv.servCode,recv.getCliCode(),cliAckOrderMsg.END_PRODUCT);
                  clout.write(reply.toMsg());
                  clout.flush();
                  serv.msgBox.append("Ordine rifiutato, provvedere ad un rifornimento scorte\n");
                }
              }catch(Exception err){
                cliAckOrderMsg reply = new cliAckOrderMsg(cliAckOrderMsg.NO_ORDER_CODE,serv.servCode,recv.getCliCode(),cliAckOrderMsg.ERROR_ON_CODE);
                clout.write(reply.toMsg());
                clout.flush();
                //serv.msgBox.append("-1\n");
                serv.msgBox.append("Errore nella gestione degli ordini\n");  //---------------
              };
            }else{ // Se  attiva la catena di server
              //serv.msgBox.append("1\n");
              try{
                if (serv.db.checkOrder(recv)){ // L'ordine pu essere servito
                  //serv.msgBox.append("2\n");
                  pendingElem order = new pendingElem(serv.db.getOrderCode(serv.servCode),serv.getWeight(),recv.getCliCode(),recv.getAllInfo());
                  //serv.msgBox.append("3\n");
                  serv.db.addOrder(order); // l'ordine viene registrato nel database come pendente
                  //serv.msgBox.append("4\n");
                  serv.sendNextMsg(new servSendOrderMsg(serv.servCode,order.getOrderCode(),order.getWeight(),recv));
                  //serv.msgBox.append("5\n");
                  serv.registerClient(order.getOrderCode(),this);
                }else{ // A livello intra-server non si verificano gli ordini pendenti per premiare l'ordine ricevuto in precedenza e non ancora confermato
                  cliAckOrderMsg reply = new cliAckOrderMsg(cliAckOrderMsg.NO_ORDER_CODE,serv.servCode,recv.getCliCode(),cliAckOrderMsg.END_PRODUCT);
                  clout.write(reply.toMsg());
                  clout.flush();
                  serv.msgBox.append("Ordine rifiutato, provvedere ad un rifornimento scorte\n");
                }
              }catch(Exception err){
                cliAckOrderMsg reply = new cliAckOrderMsg(cliAckOrderMsg.NO_ORDER_CODE,serv.servCode,recv.getCliCode(),cliAckOrderMsg.ERROR_ON_CODE);
                clout.write(reply.toMsg());
                clout.flush();
                serv.msgBox.append("Errore nella gestione degli ordini\n");
              };
            }
/*            if (serv.db.checkOrder(in)) serv.msgBox.append("L'ordine pu essere accettato\n");
            else serv.msgBox.append("L'ordine  rifiutato\n");*/
          }; break;
          case stringCommand.CLI_DELETE_ORDER_CODE : {
          //serv.msgBox.append("1\n");
            cliDelOrderMsg recv  = new cliDelOrderMsg(in);
          //serv.msgBox.append("2\n");
            if (serv.monoServer){ // Se il server  uno solo si rimuove l'ordine solo localmente
              //serv.msgBox.append("3\n");
              try{
                  cliAckOrderMsg reply;
                  //serv.msgBox.append("4\n");
                  if (serv.db.unRegisterOrder(recv.getOrderCode())){ // Ordine rimosso correttamente
                    reply = new cliAckOrderMsg(recv.getOrderCode(),serv.servCode,recv.getCliCode(),cliAckOrderMsg.ORDER_ACCEPT);
                  }else{
                    reply = new cliAckOrderMsg(recv.getOrderCode(),serv.servCode,recv.getCliCode(),cliAckOrderMsg.ERROR_ON_CODE);
                  };
                  //serv.msgBox.append("6\n");
                  clout.write(reply.toMsg());
                  //serv.msgBox.append("7\n");
                  clout.flush();
                  //serv.msgBox.append("8\n");
                  serv.msgBox.append("Rimosso l'ordine "+recv.getOrderCode()+"\n");
              }catch(Exception err){
                //serv.msgBox.append("9\n");
                cliAckOrderMsg reply = new cliAckOrderMsg(cliAckOrderMsg.NO_ORDER_CODE,serv.servCode,recv.getCliCode(),cliAckOrderMsg.ERROR_ON_CODE);
                //serv.msgBox.append("10\n");
                clout.write(reply.toMsg());
                //serv.msgBox.append("11\n");
                clout.flush();
                //serv.msgBox.append("-1\n");
                serv.msgBox.append("Errore nella gestione degli ordini\n");  //---------------
              };
            }else{ // Se  attiva la catena di server
              //serv.msgBox.append("1\n");
              try{
                  //serv.msgBox.append("2\n");
                  serv.sendNextMsg(new servDelOrderMsg(serv.servCode,recv.getOrderCode(),recv.getCliCode()));
                  //serv.msgBox.append("3\n");
                  serv.registerClient(recv.getOrderCode(),this);
                  //serv.msgBox.append("4\n");
              }catch(Exception err){
                cliAckOrderMsg reply = new cliAckOrderMsg(cliAckOrderMsg.NO_ORDER_CODE,serv.servCode,recv.getCliCode(),cliAckOrderMsg.ERROR_ON_CODE);
                clout.write(reply.toMsg());
                clout.flush();
                serv.msgBox.append("Errore nella gestione degli ordini\n");
              };
            };
          };break;
          case stringCommand.CLI_ACCEPT_NEW_SERVER_CODE : {
            cliAcceptNewServerMsg recv  = new cliAcceptNewServerMsg(in);
            serv.msgBox.append("Ricevuta richiesta per l'attivazione di un nuovo server\n");
            serv.incCl();                          // Incremento il clock Logico
            if (!serv.servList.contains(recv.getServCode())) serv.addServList(recv.getServCode()); // Aggiungo il nuovo server alla lista dei server
            serv.resetServListPos();
            cliServAckMsg reply = new cliServAckMsg(true,serv.getServCode(),serv.getCl(),serv.servList); // Risponde con il suo codice
            reply.setAccept(true);  // (serv.newServer(reply,clout));
            clout.write(reply.toMsg());
            clout.flush();
            serv.msgBox.append("Invio informazioni sul database\n");
            serv.db.uploadDb(clout,serv.command.PROD_DB_FILE);
            serv.db.uploadOrderDb(clout,serv.command.ORDER_DB_FILE);
            serv.msgBox.append("Attivata la procedura di registrazione\n");
            serv.newPrevServer(recv.getIp(),recv.getPort(),clout); // IP e Porta del nuovo previous server
            serv.msgBox.append("Previous Thread attivati\n");
            clin.readLine();
            if(serv.monoServer){  // Siamo nel caso di sistema attualmente monoServer
              serv.newNextServer(recv.getIp(),recv.getPort());
              serv.monoServer = false;
            }else{  // Siamo nel caso di sistema con pi Server
              serv.msgBox.append("invio di : "+recv.getIp()+Integer.toString(recv.getPort()));
              serv.sendNextMsg(new servNewPrevServerMsg(recv.getServCode(),recv.getIp(),recv.getPort(),serv.getCl()));
            };
            serv.msgBox.append("Next Thread Verificati\n");
            clout.write((new genericAckMsg()).toMsg());
            clout.flush();
          }; break;
        };
      };
    }catch(Exception e){ serv.msgBox.append("Impossibile gestire la richiesta del cliente\n"); };
    try{
      clin.close();
      clout.close();
      cliSocket.close();
      serv.msgBox.append("Connessione terminata\n");
    }catch(Exception err) {serv.msgBox.append("Impossibile terminare la comunicazione\n"); };
  }
  String getCliCode() { return cliCode; };

  void cliAckOrder(String orderCode) {
    try {
      cliAckOrderMsg reply = new cliAckOrderMsg(orderCode,serv.servCode,this.getCliCode(),cliAckOrderMsg.ORDER_ACCEPT);
      clout.write(reply.toMsg());
      clout.flush();
      serv.msgBox.append("Ordine "+orderCode+" registrato correttamente\n");
    }catch(Exception err){
      serv.msgBox.append("impossibile inviare conferma del ordine al cliente");
    };
  };
  void cliAckOrder(short errorCode, String orderCode) {
    try {
      cliAckOrderMsg reply = new cliAckOrderMsg(orderCode,serv.servCode,this.getCliCode(),errorCode);
      clout.write(reply.toMsg());
      clout.flush();
      switch(errorCode){
        case cliAckOrderMsg.END_PRODUCT : serv.msgBox.append("Ordine "+orderCode+" rifiutato causa esaurimento scorte\n"); break;
        case cliAckOrderMsg.ERROR_ON_CODE : serv.msgBox.append("Codice "+orderCode+" inesistente\n"); break;
        case cliAckOrderMsg.ORDER_ACCEPT : serv.msgBox.append("Ordine "+orderCode+" Registrato correttamente\n"); break;
        default: serv.msgBox.append("Ordine "+orderCode+" Abortito\n"); break;
      };

    }catch(Exception err){
      serv.msgBox.append("impossibile inviare rapporto sul ordine al cliente");
    };
  };



}

/** Si incarica di ricevere i messaggi dal Previous server, di eseguire le mansioni richieste da tali messaggi e quindi inoltrarne comunicazione al next server, attraverso il canale di out.*/
class prevInThread extends Thread {
  boolean onConflict = false; // Variabile che memorizza la condizione di conflitto
  BufferedReader in;
  BufferedWriter pnpOut;
  Server serv;   // Variabile per accedere alle funzionalit del server
  String data;
  prevInThread(BufferedReader din, PipedReader pnpin, Server Serv){
    try {
      in = din;
      serv = Serv;
      //pnpOut = new BufferedWriter(new PipedWriter(pnpin));
    } catch(Exception err){
      serv = Serv;
      serv.msgBox.append("Impossibile inizializzare il Previous In Thread\n");
    };
  };
  public void run(){
    short opcode;
    boolean end = false;
    serv.msgBox.append("Previous In su "+Integer.toString(serv.portPrev)+" connesso\n");
    serv.setPrevConnection();
    try {
      while(!end) {
        do {
          data=in.readLine();
          serv.msgBox.append("RICEVUTO PREVIN: "+data+"\n");
          //if (data==null) { data = ""; sleep(1000); }
        } while (data.compareToIgnoreCase("")==0);
        opcode = Msg.getOpCode(data);
        switch (opcode){
          case stringCommand.SERV_TEST_CODE : {
            servTestMsg forward = new servTestMsg(data);
            if (forward.getServCode().compareTo(serv.getServCode())==0) { // se il messaggio l'ho generato io ne interrompo la circolazione e visualizzo i risultati
              serv.msgBox.append("---- risultato del TEST ------\n");
              serv.msgBox.append("Server Richiedente : "+forward.getServCode()+"\n");
              for(int i=0;i<forward.getNumInfo();i++) { serv.msgBox.append(Integer.toString(i+1)+" Server :"+forward.getInfo(i)+"\n"); };
              serv.msgBox.append("---- il test ha avuto successo ------\n");
            }else{ // Altrimenti il pacchetto dovr continuare il suo cammino nell'anello
              forward.addInfo(serv.getServCode());
              serv.sendNextMsg(forward);
//              pnpOut.write(forward.toMsg()+"\n");
//              pnpOut.flush();
              serv.msgBox.append("ACCODATO NEXTOUT: "+data+"\n");
            };
          }; break;
          case stringCommand.SERV_CONNECT_CODE : {
            //servConnectMsg recv = new servConnectMsg(data);    // GESTIONE DEI PACCHETTI
             //  necessario aggiornare le info sul sistema
            //pnpOut.write(recv.toMsg());
          }; break;
          case stringCommand.SERV_SEND_ORDER_CODE : {
            //serv.msgBox.append("sleep -->");
            //this.sleep(1800);
            //serv.msgBox.append(" end sleep\n");
            servSendOrderMsg forward = new servSendOrderMsg(data);
            if (forward.getServCode().compareTo(serv.servCode)==0){  // L'ordine  stato inviato dal server corrente
              //serv.msgBox.append("100\n");
              if (forward.getWeight()<100) serv.lastWinner = true;
              else serv.lastWinner = false;
              orderElem order = new orderElem(forward.getOrderCode(),forward.order.getCliCode(),forward.order.product);
              //serv.msgBox.append("101\n");
              serv.db.delOrder(new pendingElem(forward.getOrderCode(),forward.getWeight(),forward.order.getCliCode(),forward.order.product));
              //serv.msgBox.append("102\n");
              serv.db.registerOrder(order);
              //serv.msgBox.append("103\n");
              serv.unRegisterClient(order.getOrderCode());
              //serv.msgBox.append("104\n");
            }else{ // verifico la possibilit di registrare l'ordine
              serv.msgBox.append("100\n");
              orderElem order = new orderElem(forward.getOrderCode(),forward.order.getCliCode(),forward.order.product);
//              pnpOut.write(forward.toMsg());
//              pnpOut.flush();
              if(serv.db.checkOrder(order)){ // Allora  possibile registrare l'ordine
                serv.msgBox.append("101\n");
                serv.db.registerOrder(order);
                serv.msgBox.append("102\n");
                serv.sendNextMsg(forward);
              }else{ // Verifico se sacrificando un ordine pendente  possibile servire l'ordine
                serv.msgBox.append("103\n");
                pendingElem pend = new pendingElem(forward.getOrderCode(),forward.getWeight(),forward.order.getCliCode(),forward.order.product);
                serv.msgBox.append("104\n");
                int p = serv.db.checkPendingOrder(pend);
                serv.msgBox.append("105 - "+Integer.toString(p)+"\n");
                if(p>=0){ // Allora rimuovendo un ordine pendente posso servire quest'ordine
                  serv.lastWinner = false;
                  onConflict = true; // entriamo in una situazione di conflitto
                  serv.msgBox.append("106\n");
                  pendingElem elem = (pendingElem)serv.db.pendingTable.remove(p);
                  serv.db.delOrder(elem); // rimuovo l'ordine epropago la richiesta di cancellazione
                  serv.sendNextMsg(new servDelOrderMsg(serv.getServCode(),elem.getOrderCode(),elem.getCliCode()));
                  if (forward.getWeight()>=100) forward.setWeight(forward.getWeight()-100); // sistemo il peso
                  serv.db.registerOrder(order); // registro l'ordine
                  serv.sendNextMsg(forward);    // e lo faccio proseguire
                }else{ // L'ordine non pu essere servito in nessun modo
                 // quindi non faccio nulla perdendo tale ordine.
                }
              };
            };
          }; break;
          case stringCommand.SERV_DELETE_ORDER_CODE : {
            //serv.msgBox.append("sleep -->");
            //this.sleep(1800);
            //serv.msgBox.append(" end sleep\n");
            servDelOrderMsg forward = new servDelOrderMsg(data);
            if (forward.getServCode().compareTo(serv.servCode)==0){  // L'ordine  stato inviato dal server corrente
              //serv.msgBox.append("100\n");
              if(serv.db.unRegisterOrder(forward.getOrderCode())) { // Ordine eliminato correttamente
                serv.unRegisterClient(forward.getOrderCode());
              }else{ // L'ordine non  presente
                if (onConflict) { // Siamo in un conflitto percui l'ordine viene ripudiato
                  serv.unRegisterClient(forward.getOrderCode(),cliAckOrderMsg.END_PRODUCT);
                  onConflict = false;
                }else{ // Non ci sono conflitti quindi il codice  sbagliato
                  serv.unRegisterClient(forward.getOrderCode(),cliAckOrderMsg.ERROR_ON_CODE);
                }

              };
              //serv.msgBox.append("101\n");

              serv.msgBox.append("102\n");
            }else{ // verifico la possibilit di eliminare l'ordine
              //orderElem order = new orderElem(forward.getOrderCode(),forward.getCliCode(),forward.product);
              //serv.msgBox.append("100\n");

              serv.db.unRegisterOrder(forward.getOrderCode());
              //serv.msgBox.append("101\n");
              serv.sendNextMsg(forward);
//              pnpOut.write(forward.toMsg());
              //serv.msgBox.append("102\n");
//              pnpOut.flush();
              //serv.msgBox.append("103\n");
            };
          }; break;
          case stringCommand.SERV_NEW_NEXT_SERVER_CONNECT_CODE : { // un nuovo server nella catena
            servNewNextServerMsg recv = new servNewNextServerMsg(data);
            if (!serv.servList.contains(recv.getServCode())) serv.addServList(recv.getServCode());
            serv.resetServListPos();
            if (serv.isSetNextConnection()){ // Se il nuovo next server  il seguente
               serv.newNextServer(recv.getIp(),recv.getPort());
            }else{  // altrimenti
              serv.msgBox.append("KKK\n");
              serv.sendNextMsg(recv); // Reinvio il messaggio al server successivo
            };
          }; break;
          case stringCommand.SERV_NEW_PREV_SERVER_CONNECT_CODE : { // un nuovo server nella catena
            servNewNextServerMsg recv = new servNewNextServerMsg(data);
            if (!serv.servList.contains(recv.getServCode())) serv.addServList(recv.getServCode());
            serv.resetServListPos();
            serv.setCl(recv.getCl());
            if (serv.isSetNextConnection()){ // Se il nuovo next server non  il seguente
              serv.msgBox.append("ZZZ\n");
              serv.sendNextMsg(recv); // Reinvio il messaggio al server successivo
            }else{  // altrimenti
              serv.newNextServer(recv.getIp(),recv.getPort()); // Attivo il nuovo next Server
            };
          }; break;
          case stringCommand.SERV_CRASH_SERVER_CODE : { // recovery dal crash di un server
            servCrashServerMsg recv = new servCrashServerMsg(data);
            serv.setCl(recv.getCl());
            if (!recv.info.contains(serv.getServCode())) recv.addInfo(serv.getServCode()); // Aggiorno la lista dei server sopravvissuti
            if (serv.isSetNextConnection()){ // Il server crashato non  il next del server corrente
              serv.msgBox.append("YYY\n");
              serv.sendNextMsg(recv); // Propago il messaggio
            }else{ // Il server crashato  il next del server corrente, quindi riaggancio il nuovo previous
              serv.servList.clear();
              for (int k=0;k<recv.getNumInfo();k++){ serv.addServList(recv.getInfo(k)); };
              if (serv.newNextServer(recv.getIp(),recv.getPort()))
               serv.sendNextMsg(new servRecoveryCompletedMsg(serv.getServCode(),serv.servList));
            };
          }; break;
          case stringCommand.SERV_RECOVERY_COMPLETED_CODE : { // recovery dal crash di un server completato
            servRecoveryCompletedMsg recv = new servRecoveryCompletedMsg(data);
            if (recv.getServCode().compareToIgnoreCase(serv.getServCode())!=0){ // se il messaggio non  partito da questo server
              serv.servList = recv.getAllInfo();
              serv.resetServListPos();
              //serv.msgBox.append("WWW\n");
              serv.sendNextMsg(recv);
            }else{ // se il messaggio  partito da questo server lo fermo
              serv.msgBox.append("Protocollo di recovery completato con successo\n");
            };
            serv.unRegisterAllClient();
          }; break;
        };
      };
    }catch(Exception e){ serv.resetPrevConnection(); serv.msgBox.append("Errore nell'esecuzione del PrevIn Thread\n"); };
    try{
      for(int k=0;k<10000;k++) {}; // ciclo di ritardo
      in.close();
      serv.resetPrevConnection();
      serv.closePrevConnection();
      ArrayList inf = new ArrayList();
      inf.add(serv.getServCode());
      if(serv.isSetNextConnection()) { //  caduto solo il previous allora siamo nel caso di pi server sopravissuti
        if (serv.isCrash()){ // Se non  un crash sar l'accettazione di un nuovo server
          serv.msgBox.append("Invio messaggio di recovery\n"); // quindi non si deve far nulla
          serv.sendNextMsg(new servCrashServerMsg(serv.getServCode(),serv.ipPrev,serv.portPrev,serv.incCl(),inf));/////////////// <---------------  CRASH SERVER
          serv.recoveryPrevServer();
        } else {
          serv.setCrash();
        };
      } else { // Il sistema ritorna monoServer
        serv.monoServer = true;                // Reimposto il sistema come monoserver
        serv.incCl();                          // Incremento il clock Logico
        serv.servList.clear();                 // Pulisco la lista dei server
        serv.addServList(serv.getServCode()); // Aggiungo il server corrente
        serv.resetServListPos();               // reinizializzo il contatore
        serv.db.delAllOrder();
        serv.unRegisterAllClient();
        serv.msgBox.append("Thread Previous In terminato\n");
      }
    }catch(Exception err) {serv.msgBox.append("Impossibile chiudere il thread Previous In\n"); };
  }
}

/** Si incarica di ricevere i messaggi dal Next server, di eseguire le mansioni richieste da tali messaggi e quindi inoltrarne comunicazione al Previous server, attraverso il canale di out.*/
class nextInThread extends Thread {
  BufferedReader in;
  Server serv;
  //BufferedWriter nppOut;
  String data;
  nextInThread(BufferedReader din, PipedReader nppin, Server Serv){
    try {
      serv = Serv;
      in = din;
      //nppOut = new BufferedWriter(new PipedWriter(nppin));
    }catch(Exception Err){
      serv = Serv;
      serv.msgBox.append("Impossibile inizializzare il Next In Thread\n");
    };
  };
  public void run(){
    short opcode;
    boolean end=false;
    serv.setNextConnection();
    try {
      serv.msgBox.append("Next In su "+Integer.toString(serv.portNext)+" connesso\n");
      while(!end) {
        do {
          data=in.readLine();
          serv.msgBox.append("RICEVUTO NEXTIN: "+data+"\n");
          //if (data==null) { data = ""; sleep(1000); }
        } while (data.compareToIgnoreCase("")==0);
        opcode = Msg.getOpCode(data);
        switch (opcode){
          case stringCommand.SERV_NEW_NEXT_SERVER_CONNECT_CODE : { // un nuovo server nella catena
            servNewNextServerMsg recv = new servNewNextServerMsg(data);
            //serv.resetNextConnection();
            serv.ipNext = recv.getIp();        // a ricevere la richiesta di attivazione per la
            serv.portNext = recv.getPort();    // nuova che arriver dal previous server.
            //serv.closeNextConnection();        // Chiudo la connesione attuale e mi preparo
            end = true;    // CHIUDO IL THREAD
          }; break;
          case stringCommand.SERV_TEST_CODE : {
            servTestMsg forward = new servTestMsg(data);
            if (forward.getServCode().compareTo(serv.getServCode())==0) { // se il messaggio l'ho generato io ne interrompo la circolazione e visualizzo i risultati
              serv.msgBox.append("---- risultato del TEST ------\n");
              serv.msgBox.append("Server Richiedente : "+forward.getServCode()+"\n");
              for(int i=0;i<forward.getNumInfo();i++) { serv.msgBox.append(Integer.toString(i+1)+" Server :"+forward.getInfo(i)+"\n"); };
              serv.msgBox.append("---- il test ha avuto successo ------\n");
            }else{ // Altrimenti il pacchetto dovr continuare il suo cammino nell'anello
              forward.addInfo(serv.getServCode());
              serv.sendPrevMsg(forward);
//              pnpOut.write(forward.toMsg()+"\n");
//              pnpOut.flush();
              serv.msgBox.append("ACCODATO PREVOUT: "+data+"\n");
            };
          }; break;

        };
      };
    }catch(Exception e){ serv.resetNextConnection(); serv.msgBox.append("Errore nell'esecuzione del NextIn Thread\n"); };
    try{
      //in.close();
      serv.resetNextConnection();
      //nppOut.close();
      serv.closeNextConnection();
      serv.msgBox.append("Thread Next In terminato\n");
    }catch(Exception err) {serv.msgBox.append("Impossibile chiudere il thread Next In\n"); };
  }
}
/*
class prevOutThread extends Thread {
  BufferedWriter out;
  //BufferedReader nppIn;
  Server serv;
  String data;
  prevOutThread(BufferedWriter dout, PipedReader nppin, Server Serv){
    out = dout;
    //nppIn = new BufferedReader(nppin);
    serv = Serv;
  };
  public void run(){
    short opcode;
    boolean end = false;
    try {
      serv.msgBox.append("Previous Out su "+Integer.toString(serv.portPrev)+" connesso\n");
      while(!end) {
        do {
          data = nppIn.readLine();
          serv.msgBox.append("RICEVUTO PREVOUT: "+data+"\n");
          //if (data==null) { data = ""; sleep(1000); }
        } while (data.compareToIgnoreCase("")==0);
        opcode = Msg.getOpCode(data);
        switch (opcode){
          case stringCommand.SERV_NEW_PREV_SERVER_CONNECT_CODE : { // Il thread deve terminare dopo aver informato il previous Server
            out.write((new servNewNextServerMsg()).toMsg());
            out.flush();
          }; break;
        };
      };
    }catch(Exception e){ serv.msgBox.append("Errore nell'esecuzione del PreviousOut Thread\n"); };
    try{
      out.close();
      nppIn.close();
      serv.msgBox.append("Thread Previous Out terminato\n");
    }catch(Exception err) {serv.msgBox.append("Impossibile chiudere il thread Previous Out\n"); };
  }

  void sendMsg(servMsg msg) throws Exception {
    out.write(msg.toMsg());
    out.flush();
  };
  void sendNewServerMsg() throws Exception {
    servNewPrevServerMsg msg = new servNewPrevServerMsg(serv.getServCode(),serv.getCl());
    out.write(msg.toMsg());
    out.flush();
  };
}


class nextOutThread extends Thread {
  BufferedWriter out;
  BufferedReader pnpIn;
  Server serv;
  nextOutThread(BufferedWriter dout, PipedReader pnpin, Server Serv){
    out = dout;
    pnpIn = new BufferedReader(pnpin);
    serv = Serv;
  };

  public void run(){
    String data;
    short opcode;
    boolean end = false;
    try {
      serv.msgBox.append("Next Out su "+Integer.toString(serv.portNext)+" connesso\n");
      while(!end) {
        // serv.msgBox.append("1\n");
        do {
            data = pnpIn.readLine();
            serv.msgBox.append("RICEVUTO NEXTOUT: "+data+"\n");
          //if (data==null) { data = ""; sleep(1000); }
        } while (data.compareToIgnoreCase("")==0);
        opcode = Msg.getOpCode(data);
        switch (opcode){
          case stringCommand.SERV_TEST_CODE : {
            out.write(data+"\n");
            out.flush();
          }; break;
          case stringCommand.SERV_NEW_NEXT_SERVER_CONNECT_CODE : {
            //servConnectMsg recv = new servConnectMsg(data);
            //servAckMsg reply = new servAckMsg(serv.getCl(),recv.getServCode());
            //serv.msgBox.append("Server ack creato\n");
            //if (recv.getCl()!= serv.getCl()) { //  necessario aggiornare le info sul sistema
            // reply.addInfo("SERV1","127.0.0.1");
            // reply.addInfo("PORT1","4000");
            // ecc... andranno messi bene
            //}else{
            //};
            //serv.msgBox.append("3\n");
          }; break;
          default: {  // In tutti gli altri casi si limita a passare il messaggio al nodo successivo
            out.write(data+"\n");
            out.flush();
          }; break;
        };
      };
    }catch(Exception e){ serv.msgBox.append("Errore nell'esecuzione del NextOut Thread\n"); };
    try{
      out.close();
      pnpIn.close();
      serv.msgBox.append("Connessione NextOut terminata\n");
    }catch(Exception err) {serv.msgBox.append("Impossibile chiudere il thread Next Out\n"); };
  }
  void sendMsg(servMsg msg) throws Exception {
    out.write(msg.toMsg());
    out.flush();
  };
  void sendNewServerMsg() throws Exception {
    servNewNextServerMsg msg = new servNewNextServerMsg(serv.getServCode(),serv.getCl());
    out.write(msg.toMsg());
    out.flush();
  };
}
*/