package reti;
/**
 * Title:        Progetto di reti di calcolatori
 * Description:  Sistema di server commerciali per la vendita di prodotti via internet
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Alessandro Celli
 * @version 1.0
 */
 import java.net.*;
 import java.io.*;
 import java.io.Writer;
 import java.util.ArrayList;
 import java.util.Hashtable;
 import java.util.*;
 public class database {
  // ************************ VARIABILI DI GESTIONE DEL DATABASE ************************
  ArrayList orderTable;       // Tabella degli Ordini contiene tutti gli ordini effettuari e non ancora trasferiti su disco
  ArrayList pendingTable;     // tabella degli ordini pendenti non ancora registrati
  Hashtable prodTable;        // tabella dei prodotti disponibili, contiene (codProd, Quantit)
  Hashtable prodPendingTable; // Tabella dei prodotti gi rihiesti ma non ancora registrati (prodCode(cliCode Qta))


  /** Costruttore della classe database, inizializza le variabili delegate al mantenimento dei database*/
  public database() throws Exception {
    orderTable = new ArrayList();
    pendingTable = new ArrayList();
    prodTable = new Hashtable();
    prodPendingTable = new Hashtable();
  };

  /** Inizializza le strutture dinamiche del database legendole dall'archivio fisico */
  public synchronized void initDb(String dbname, String orderdb) throws Exception {
    BufferedReader in = new BufferedReader(new FileReader(new File(dbname)));
    String app;
    String tmp;
    int pos;
    while ((app = in.readLine())!=null){  // Acquisisce il DB dei prodotti
      pos = app.indexOf('|') ;
      tmp = app.substring(0,pos);
      app = app.substring(pos+1);
      pos = app.indexOf('|') ;
      app = app.substring(0,pos);
      prodTable.put(app,new Integer(tmp));
      prodPendingTable.put(app,new Hashtable());
    };
    in.close();
    in = new BufferedReader(new FileReader(new File(orderdb)));
    while ((app = in.readLine())!=null){  // Acquisisce il DB dei prodotti
      orderTable.add(new orderElem(app));
    };
    in.close();
/*    for (pos = 0;pos<prodTable.size();pos++){
      prodPendingTable.put(((String)prodTable.get()
      prodPendingTable.put(((String)prodTable.keys().nextElement()),new Integer(0));
    };*/
  };
/** Permette di aggiornare il contenuto del proprio database ricevendone il contenuto dal remoto ( il next server ) */
  public synchronized void updateDb(BufferedReader in, String dbname) throws Exception { // Aggiorna Il DB Ricevendo i dati da uno stream
    BufferedWriter out = new BufferedWriter(new FileWriter(new File(dbname)));
    String app;
    try{
      while ((app = in.readLine()).compareTo(stringCommand.END_OF_FILE)!=0){  // Acquisisce il DB dei prodotti
        out.write(app);
        out.newLine();
      }
    }catch(Exception Err){};
    out.close();
  }
  public synchronized void updateOrderDb(BufferedReader in, String dbname) throws Exception { // Aggiorna Il DB Ricevendo i dati da uno stream
    BufferedWriter out = new BufferedWriter(new FileWriter(new File(dbname)));
    String app;
    try{
      while ((app = in.readLine()).compareTo(stringCommand.END_OF_FILE)!=0){  // Acquisisce il DB degli ordini
        out.write(app);
        out.newLine();
      }
    }catch(Exception Err){};
    out.close();
  }


/** Trasferisce il contenuto del proprio database ad un server che ne f richiesta */
  public synchronized void uploadDb(BufferedWriter out,String dbname) throws Exception { // Invia Il DB sullo stream ricevuto come parametro
    BufferedReader in = new BufferedReader(new FileReader(new File(dbname)));
    String app;
    int pos;
    String cod;
    while ((app = in.readLine())!=null){  // Acquisisce il DB dei prodotti
      pos = app.indexOf('|');
      app = app.substring(pos+1);
      pos = app.indexOf('|');
      cod = app.substring(0,pos);
      app = app.substring(pos+1);
     out.write(((Integer)prodTable.get(cod)).toString()+"|"+cod+"|"+app); // Aggiorna il contenuto del Db con le nuove informazioni
      out.newLine();
    };
    out.write(stringCommand.END_OF_FILE);
    out.newLine();
    out.flush();
    in.close();
  }

  /** Trasferisce il contenuto del proprio database ad un server che ne f richiesta */
  public synchronized void uploadOrderDb(BufferedWriter out,String dbname) throws Exception { // Invia Il DB sullo stream ricevuto come parametro
    //BufferedReader in = new BufferedReader(new Fi(new File(dbname)));
    String app;
    int pos;
    String cod;
    out.write(getOrderTable());
    out.write(stringCommand.END_OF_FILE);
    out.newLine();
    out.flush();
    //in.close();
  }

  /** Restituisce un Array contenente la lista di tutti i prodotti disponibili per la vendita */
  public ArrayList readProdDB() throws Exception {
    BufferedReader in = new BufferedReader(new FileReader(new File(stringCommand.PROD_DB_FILE)));
    ArrayList out = new ArrayList();
    String app;
    String cod,qta,tmp;
    int pos;
    while ((app = in.readLine())!=null){  // Legge dal DB dei prodotti e trasferisce i dati sullo stream di output
      pos = app.indexOf('|');
      qta = app.substring(0,pos);
      app = app.substring(pos+1);
      pos = app.indexOf('|');
      cod = app.substring(0,pos);
      app = app.substring(pos+1);
      if ((tmp = ((Integer)prodTable.get(cod)).toString())==null)  app = qta+"|"+cod+"|"+app;
      else app = tmp+"|"+cod+"|"+app;
      out.add(app); // Aggiorna il contenuto del Db con le nuove informazioni
    };
    in.close();
    return out;
  };

  /** Scarica le tabelle dinamiche aggiornando il contenuto del Database */
  public synchronized void flushDb(String dbname) throws Exception {
    BufferedReader in = new BufferedReader(new FileReader(new File(dbname)));
    BufferedWriter out = new BufferedWriter(new FileWriter(new File(dbname+".tmp")));
    String app;
    String cod;
    int pos;
    try{
      while ((app = in.readLine())!=null){  // Acquisisce il DB dei prodotti
        pos = app.indexOf('|');
        app = app.substring(pos+1);
        pos = app.indexOf('|');
        cod = app.substring(0,pos);
        app = app.substring(pos+1);
        out.write(((Integer)prodTable.get(cod)).toString()+"|"+cod+"|"+app); // Aggiorna il contenuto del Db con le nuove informazioni
        out.newLine();
      };
      out.close();
      in.close();
      in = new BufferedReader(new FileReader(new File(dbname+".tmp")));
      out = new BufferedWriter(new FileWriter(new File(dbname)));
      while ((app = in.readLine())!=null){  // Acquisisce il DB dei prodotti
        out.write(app);
        out.newLine();
      }
      //prodTable.clear();
      out.close();
      in.close();
    }catch(Exception Err){};
  };

  /** Inserisce un ordine nella coda dei pendenti in attesa di poterlo registrare */
  public synchronized void addOrder(pendingElem elem) throws Exception {
    int Qta=0;
    Hashtable tmpTable;
    Integer tmpQta;
    pendingTable.add(elem); // Aggiungo l'ordine alla tabella degli ordini pendenti
    for(int i=0;i<elem.getNumProd();i++){ // Aggiungo i prodotti richiesti alla tabella dei prodotti pendenti
      tmpTable = (Hashtable)prodPendingTable.get(elem.getCodProd(i));
      if (tmpTable!=null) {
        tmpQta = ((Integer)tmpTable.get(elem.getCliCode()));
        if (tmpQta!=null) Qta = tmpQta.intValue();
        else Qta = 0;
      }else Qta = 0;
      // prodPendingTable : (prodCode(cliCode Qta))
      tmpTable = (Hashtable)prodPendingTable.get(elem.getCodProd(i));
      //tmpTable.remove(elem.getCliCode());
      tmpTable.put(elem.getCliCode(),new Integer(Qta+elem.getQtaProd(i))); // Ho aggiornato la prodPendingTable
      Qta = ((Integer)prodTable.get(elem.getCodProd(i))).intValue();
      prodTable.remove(elem.getCodProd(i));
      prodTable.put(elem.getCodProd(i),new Integer(Qta-elem.getQtaProd(i))); // Ho aggiornato la prodTable
    };
  };

  /** Rimuove un ordine dalla coda dei pendenti, l'ordine rimosso potr essere inserito nella coda degli ordini registrati oppure potr essere eliminato a causa di un conflitto*/
  public synchronized void delOrder(pendingElem elem) throws Exception {
    int Qta=0;
    Hashtable tmpTable;
    for(int i=0;i<pendingTable.size();i++) {
      if(((pendingElem)pendingTable.get(i)).getOrderCode().compareToIgnoreCase(elem.getOrderCode())==0)
        pendingTable.remove(i);
    }
    for(int i=0;i<elem.getNumProd();i++){ // Rimuovo i prodotti richiesti alla tabella dei prodotti pendenti
      Qta = ((Integer)((Hashtable)prodPendingTable.get(elem.getCodProd(i))).get(elem.getCliCode())).intValue();
      // prodPendingTable : (prodCode(cliCode Qta))
      tmpTable = (Hashtable)prodPendingTable.get(elem.getCodProd(i));
      tmpTable.remove(elem.getCliCode());
      //tmpTable.put(elem.getCliCode(),new Integer(Qta-elem.getQtaProd(i))); // Ho aggiornato la prodPendingTable
      Qta = ((Integer)prodTable.get(elem.getCodProd(i))).intValue();
      prodTable.remove(elem.getCodProd(i));
      prodTable.put(elem.getCodProd(i),new Integer(Qta+elem.getQtaProd(i))); // Ho aggiornato la prodTable
/*      Qta = ((Integer)prodPendingTable.get(elem.getCodProd(i))).intValue();
      prodPendingTable.remove(elem.getCodProd(i));
      prodPendingTable.put(elem.getCodProd(i),new Integer(Qta+elem.getQtaProd(i)));*/
    };
  };

  public synchronized void delAllOrder() throws Exception {
    int Qta=0;
    Hashtable tmpTable;
    pendingElem elem;
    for(int j=0;j<pendingTable.size();j++) {
      elem = (pendingElem)pendingTable.remove(j);
      for(int i=0;i<elem.getNumProd();i++){ // Rimuovo i prodotti richiesti alla tabella dei prodotti pendenti
        Qta = ((Integer)((Hashtable)prodPendingTable.get(elem.getCodProd(i))).get(elem.getCliCode())).intValue();
        tmpTable = (Hashtable)prodPendingTable.get(elem.getCodProd(i));
        tmpTable.remove(elem.getCliCode());
        Qta = ((Integer)prodTable.get(elem.getCodProd(i))).intValue();
        prodTable.remove(elem.getCodProd(i));
        prodTable.put(elem.getCodProd(i),new Integer(Qta+elem.getQtaProd(i))); // Ho aggiornato la prodTable
      };
    };
  };


  /** Registra un ordine nella lista degli ordini */
  public synchronized void registerOrder(orderElem elem)throws Exception {
    int Qta=0;
    orderTable.add(elem); // Aggiungo l'ordine alla tabella degli ordini
    for(int i=0;i<elem.getNumProd();i++){ // Rimuovo i prodotti richiesti alla tabella dei prodotti disponibili
      Qta = ((Integer)prodTable.get(elem.getCodProd(i))).intValue();
      prodTable.remove(elem.getCodProd(i));
      prodTable.put(elem.getCodProd(i),new Integer(Qta-elem.getQtaProd(i)));
    };
  };

  /** Rimuove un ordine dalla coda degli ordini, l'ordine rimosso sar dovuto alla richiesta del cliente oppure potr essere eliminato a causa di un conflitto*/
  public synchronized void unRegisterOrder(orderElem elem)throws Exception {
    int Qta=0;
    orderTable.remove(elem);
    for(int i=0;i<elem.getNumProd();i++){ // Aggiungo i prodotti richiesti alla tabella dei prodotti pendenti
      Qta = ((Integer)prodTable.get(elem.getCodProd(i))).intValue();
      prodTable.remove(elem.getCodProd(i));
      prodTable.put(elem.getCodProd(i),new Integer(Qta+elem.getQtaProd(i)));
    };
  };

  public synchronized boolean unRegisterOrder(String ordercode)throws Exception {
    int Qta=0;
    orderElem elem = null;
    boolean result = false;
    for (int i=0;i<orderTable.size();i++){
      if(ordercode.compareToIgnoreCase(((orderElem)orderTable.get(i)).getOrderCode())==0)
        elem = (orderElem)orderTable.remove(i);
    };
    if (elem!=null) {
      result = true;
      for(int i=0;i<elem.getNumProd();i++){ // Aggiungo i prodotti richiesti alla tabella dei prodotti disponibili
        Qta = ((Integer)prodTable.get(elem.getCodProd(i))).intValue();
        prodTable.remove(elem.getCodProd(i));
        prodTable.put(elem.getCodProd(i),new Integer(Qta+elem.getQtaProd(i)));
      };
    };
    return result;
  };


  /** verifica la possibilit di registrare un ordine con le risorse disponibili.
   *  Le informazioni vengono ricostruite dalla stringa toMsg del messaggio cliSendOrderMsg */
  public synchronized boolean checkOrder(String in) throws Exception {
    cliSendOrderMsg order = new cliSendOrderMsg(in);
    return checkOrder(order);
  }

  /** verifica la possibilit di registrare un ordine con le risorse disponibili.
   *  Le informazioni vengono ricostruite dal messaggio cliSendOrderMsg */
  public synchronized boolean checkOrder(cliSendOrderMsg order) throws Exception {
    boolean result = true;
    for (int i=0;i<order.getNumInfo();i++){
      int req = Integer.parseInt((String)order.getInfo(i).get(2));
      if (((Integer)prodTable.get(order.getInfo(i).get(1))).intValue() < req) result = false;
    };
    return result;
  }

  /** verifica la possibilit di registrare un ordine con le risorse disponibili.
   *  Le informazioni vengono ricostruite dal orderElem */
  public synchronized boolean checkOrder(orderElem order) throws Exception {
    boolean result = true;
    for (int i=0;i<order.getNumProd();i++){
      int req = Integer.parseInt((String)order.getProd(i).get(2));
      if (((Integer)prodTable.get(order.getProd(i).get(1))).intValue() < req) result = false;
    };
    return result;
  }

  /** verifica la possibilit di registrare un ordine considerando anche l'eventualit di scatenare un conflitto
   *  Le informazioni vengono ricostruite dalla stringa toMsg del messaggio cliSendOrderMsg */
  /*public synchronized int checkPendingOrder(String in) throws Exception {
    cliSendOrderMsg order = new cliSendOrderMsg(in);
    return checkPendingOrder(order);
  };
*/
  /** verifica la possibilit di registrare un ordine considerando anche l'eventualit di scatenare un conflitto
   *  Le informazioni vengono ricostruite dal messaggio cliSendOrderMsg */
  public synchronized int checkPendingOrder(pendingElem order) throws Exception {
    int result = -1;
    int pt, ppt, clireq; // contenuto della prodTable, della prodPendingTable e della richiesta del cliente, rispettivamente
    pendingElem pend = (pendingElem)pendingTable.get(0);
    for (int i=0;i<order.getNumProd();i++){ // Per ogni prodotto richiesto
      clireq = order.getQtaProd(i);
      ppt = pend.getQtaProd(pend.getPosProd(order.getCodProd(i)));
      pt =  ((Integer)prodTable.get(order.getCodProd(i))).intValue();
      System.out.println("ppt+pt :"+Integer.toString(ppt)+" + "+Integer.toString(pt)+" = "+Integer.toString(ppt+pt)+"\n");
      System.out.println("clireq :"+Integer.toString(clireq));
      if ((pt+ppt) >= clireq){ // L'ordine pu essere soddisfatto
        // Verifico quindi se l'ordine ricevuto ha priorit maggiore di quello che ho in tabella
        System.out.println("order :"+Integer.toString(order.getWeight())+" pend :"+Integer.toString(pend.getWeight())+"\n");
        if(order.getWeight() > pend.getWeight()) result = i; // se lo  lo segno
      }; // altrimenti l'ignoro
    };
/*     for(int j=0;j<pendingTable.size();j++){ //
       pend = ((pendingElem)pendingTable.get(j)); // Estraggo gli ordini pendenti
       for (int i=0;i<order.getNumProd();i++){ // Quindi per gli elementi richiesti
         clireq = pend.getQtaProd(order.getProd(i).get(2)); // estraggo la quantit richiesta nell'ordine
         pt = ((Integer)prodTable.get(order.getProd(i).get(1))).intValue(); // estraggo la disponibilit dalla tabella dei prodotti disponibili
         ppt = ((Integer)((Hashtable)prodPendingTable.get(order.getProd(i).get(1))).get(order.getCliCode())).intValue();
         if ((pt+ppt) < clireq){ // Verifico quindi se l'ordine ricevuto ha priorit maggiore di quello che ho in tabella
           if(pend.getWeight() > order.getWeight()) result = j; // se lo  lo segno
         }; // altrimenti l'ignoro
       };
    };*/
    return result;
  };

  /** verifica la possibilit di registrare un ordine considerando anche l'eventualit di scatenare un conflitto
   *  Le informazioni vengono ricostruite dal messaggio cliSendOrderMsg */
/*  public synchronized int checkPendingOrder(cliSendOrderMsg order) throws Exception {
    int result = -1;
    int pt, ppt, clireq; // contenuto della prodTable, della prodPendingTable e della richiesta del cliente, rispettivamente
    pendingElem pend;
     for(int j=0;j<pendingTable.size();j++){
       pend = ((pendingElem)pendingTable.get(j)); // Estraggo gli ordini pendenti
       for (int i=0;i<order.getNumInfo();i++){ // Quindi per gli elementi richiesti
         clireq = pend.getQtaProd(order.getInfo(i).get(1)); // estraggo la quantit richiesta nell'ordine
         pt = ((Integer)prodTable.get(order.getInfo(i).get(1))).intValue(); // estraggo la disponibilit dalla tabella dei prodotti disponibili
         ppt = ((Integer)((Hashtable)prodPendingTable.get(order.getInfo(i).get(1))).get(order.getCliCode())).intValue();
         if ((pt+ppt) < clireq){
  //         if (result<0) result = j; // Inizializzo il result a un valore diverso da quello di default che implica la mancanza di disponibilit
  //         else

  if(pend.getOrderCode().compareToIgnoreCase(((pendingElem)pendingTable.get(result)).getOrderCode())>0)
             result = j;
         };
       };
    };
    return result;
  };
*/

  String getOrderCode(String servcode){
    java.util.Calendar gc = new java.util.GregorianCalendar();
    String app = Integer.toString(gc.get(gc.YEAR));
    app = app +Integer.toString(gc.get(gc.DAY_OF_YEAR));
    app = app +Integer.toString(gc.get(gc.HOUR_OF_DAY));
    app = app +Integer.toString(gc.get(gc.MINUTE));
    app = app +Integer.toString(gc.get(gc.SECOND));
    return servcode+app;
  }

  String getProdTable() {
    String res="";
    String app;
    if (prodTable.size()!=0){
      for (Enumeration e = prodTable.keys(); e.hasMoreElements();) {
        app = (String)e.nextElement();
        res = res +app +": " +((Integer)prodTable.get(app)).toString() +"\n";
      };
    };
    return res;
  };

  String getProdPendingTable() {
    String res="";
    String app;
    if (prodPendingTable.size()!=0){
      for (Enumeration e = prodPendingTable.keys(); e.hasMoreElements();) {
        app = (String)e.nextElement();
        res = res +app;
        int i=0;
        for (Enumeration en = ((Hashtable)prodPendingTable.get(app)).keys(); en.hasMoreElements();) {
          String tmp = (String)en.nextElement();
          res = res + tmp +": " + ((String)prodPendingTable.get(app)).toString() +"\n";
        };
        if (i==0) res = res+" : 0\n";
        else res = res+"\n";
      };
    };
    return res;
  };

  String getOrderTable() {
    String res="";
    for (int i=0;i<orderTable.size();i++) {
      res = res + ((orderElem)orderTable.get(i)).toMsg();

    };
    return res;
  };

  String getPendingTable() {
    String res="";
    for (int i=0;i<pendingTable.size();i++) {
      res = res + ((pendingElem)pendingTable.get(i)).toMsg();
    };
    return res;
  };

}  // ******************************** End DATABASE class *******************************

/** Elemento che consente di memorizzare le informazioni necessarie alla registrazione di un ordine  */
class orderElem {
  String orderCode;      // Codice dell' ordine
  String cliCode;        // Codice del cliente che ha richiesto i prodotti
  ArrayList product;     // Lista dei prodotti richiesti

  orderElem() {
    orderCode = "";
    cliCode = "";
    product = new ArrayList();
  };
  orderElem(String ordercode, String clicode, ArrayList prod) {
    orderCode = ordercode;
    cliCode = clicode;
    if (prod == null) product = new ArrayList();
    else product = prod;
  };
  orderElem(String in) { // s012001146172116a00001sv01=1mb01=1
    product = new ArrayList();
    int pos = in.indexOf('');
    orderCode = in.substring(0,pos); // Estraggo il Codice dell'ordine
    in = in.substring(pos+1);
    pos = in.indexOf('');
    cliCode = in.substring(0,pos);            // Estraggo il codice del Cliente
    in = in.substring(pos+1);
    while (!(in.compareTo("") ==0)){               // Se ho esaurito l'input
      pos = in.indexOf('');
      product.add(new msgInfo(in.substring(0,pos)));   // Estraggo le info
      in = in.substring(pos+1);
    };


  };


  String getOrderCode() { return orderCode; };
  String getCliCode() { return cliCode; };
  int getNumProd() { return product.size(); };
  String getCodProd(int i) { return ((msgInfo)product.get(i)).get(1); };
  int getQtaProd(int i) { return Integer.parseInt(((msgInfo)product.get(i)).get(2)); };
  msgInfo getProd(int i) { return ((msgInfo)product.get(i)); };
  void setOrderCode(String ordercode) { orderCode = ordercode; };
  void setCliCode(String clicode) { cliCode = clicode; };
  String toMsg(){
    String app = orderCode+"";
    app = app +cliCode +"";
    for (int i=0;i<product.size();i++){  app = app +getProd(i).toMsg() +""; };
    return app +"\n";
  };
  int getPosProd(String cod) {
    int res=-1;
    for (int i=0;i<product.size();i++){
      if(cod.compareToIgnoreCase(((msgInfo)product.get(i)).get(1))==0) res = i;
    };
    return res;
  };
  int getQtaProd(String cod) {
    int pos = getPosProd(cod);
    if (pos<0) return -1;
    else return Integer.parseInt(((msgInfo)product.get(pos)).get(2));
  };
};

/** Elemento che consente la memorizzazione delle informazioni per un ordine pendente */
class pendingElem {
  String orderCode;      // Codice dell' ordine
  int weight;            // Peso del ordine, nesessario in caso di conflitto
  String cliCode;        // Codice del cliente che ha richiesto i prodotti
  ArrayList product;     // Lista dei prodotti richiesti

  pendingElem() {
    orderCode = "";
    weight = 0;
    cliCode = "";
    product = new ArrayList();
  };

  pendingElem(String ordercode, int whgt, String clicode, ArrayList prod) {
    orderCode = ordercode;
    weight = whgt;
    cliCode = clicode;
    if (prod == null) product = new ArrayList();
    else product = prod;
  };

  String getOrderCode() { return orderCode; };
  String getCliCode() { return cliCode; };
  int getWeight() { return weight; };
  int getNumProd() { return product.size(); };
  String getCodProd(int i) { return ((msgInfo)product.get(i)).get(1); };
  int getQtaProd(int i) { return Integer.parseInt(((msgInfo)product.get(i)).get(2)); };
  msgInfo getProd(int i) { return ((msgInfo)product.get(i)); };
  void setOrderCode(String ordercode) { orderCode = ordercode; };
  void setCliCode(String clicode) { cliCode = clicode; };
  void setWeight(int wght) { weight = wght; };
  String toMsg(){
    String app = orderCode +"";
    app = app +Integer.toString(weight) +"";
    app = app +cliCode +"";
    for (int i=0;i<product.size();i++){  app = app +getProd(i).toMsg() +""; };
    return app +"\n";
  };
  int getPosProd(String cod) {
    int res=-1;
    for (int i=0;i<product.size();i++){
      if(cod.compareToIgnoreCase(((msgInfo)product.get(i)).get(1))==0) res = i;
    };
    return res;
  };
  int getQtaProd(String cod) {
    int pos = getPosProd(cod);
    if (pos<0) return -1;
    else return Integer.parseInt(((msgInfo)product.get(pos)).get(2));
  };
};


/* ******************************************** F I N O   Q U I' ************************************* */
// ******************************************* MONDEZZA ****************************************
/*
  public synchronized boolean checkOrder(String in) throws Exception {
    BufferedReader din = new BufferedReader(new FileReader(new File(stringCommand.PROD_DB_FILE)));
    Hashtable dbEntry = new Hashtable();
    String tmp;
    String app;
    int pos;
    boolean result = true;
    while (din.ready()){         // Acquisisco le informazioni sul database per la verifica
      tmp = din.readLine();
      pos = tmp.indexOf('|');
      app = tmp.substring(0,pos);
      tmp = tmp.substring(pos+1);
      pos = tmp.indexOf('|');
      tmp = tmp.substring(0,pos);
      dbEntry.put(tmp, new Integer(app));
    };
    din.close();  // chiudo la lettura del DB
    for (pos=0;pos<order.getNumInfo();pos++){
      Integer val = (Integer)dbEntry.get(order.getInfo(pos).get(1));
      if (val==null) {
        result = false;
      } else {
        result = (Integer.getInteger(order.getInfo(pos).get(2))).compareTo(val) >= 0 ? true : false;
      }
    }
    return result;
  };*/

/*
  public synchronized boolean checkPendingOrder(String in) throws Exception {
    cliSendOrderMsg order = new cliSendOrderMsg(in);
    BufferedReader din = new BufferedReader(new FileReader(new File(stringCommand.PROD_DB_FILE)));
    Hashtable dbEntry = new Hashtable();
    String tmp;
    String app;
    int pos;
    boolean result = true;
    while (din.ready()){         // Acquisisco le informazioni sul database per la verifica
      tmp = din.readLine();
      pos = tmp.indexOf('|');
      app = tmp.substring(0,pos);
      tmp = tmp.substring(pos+1);
      pos = tmp.indexOf('|');
      tmp = tmp.substring(0,pos);
      dbEntry.put(tmp, new Integer(app));
    };
    din.close();  // chiudo la lettura del DB
    for (pos=0;pos<order.getNumInfo();pos++){
      Integer val = (Integer)dbEntry.get(order.getInfo(pos).get(1));
      if (val==null) {
        result = false;
      } else {
        result = (Integer.getInteger(order.getInfo(pos).get(2))).compareTo(val) >= 0 ? true : false;
      }
    }
    return result;
  };
*/

